<%  
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="text_filter.asp" -->
<%

' ***********************************************
' Common Functions
' ***********************************************

Private Function DataFromPostID(strPostID)
	Dim pidData(1)
	pidData(0) = left(strPostID,(len(strPostID)-3))
	pidData(1) = right(strPostID,3)
	DataFromPostID = pidData
End Function

Private Function PadString(strInput)
	If len(strInput) = 1 Then
		strOutput = "0" & strInput
	Else
		strOutput = strInput
	End If
	PadString = strOutput
End Function

Private Function TimeStampToDate(strTimeStamp)
	If strTimeStamp = "" Then
		RaiseError("TimeStamp Needed")
	Else
		If tzAdjust = true Then
			t_adjust = 3600 * timeAdjust
			t_zone = 3600 * timeZone
			strTimeStamp = strTimeStamp - t_adjust - t_zone	    
		Else
			strTimeStamp = strTimeStamp
		End If
		target_date = DateAdd("s",strTimeStamp,DateSerial(1970,01,01))
		Dim dateArray(5)
		dateArray(0) = Year(target_date)
		dateArray(1) = PadString(Month(target_date))
		dateArray(2) = PadString(Day(target_date))
		dateArray(3) = PadString(Hour(target_date))
		dateArray(4) = PadString(Minute(target_date))
		dateArray(5) = PadString(Second(target_date))
	End If
	TimeStampToDate = dateArray
End Function

Private Sub RaiseError(Msg,intNum)
	Err.Raise vbObjectError + intNum, "BlogWorksObject", Msg
	Err.Clear
End Sub

Private Function RaiseXMLError(strMode)
	' dummy blog post that is passed to the functions to kick in the isEmpty property
	xmlString = "<blog id=""""><author><authorname></authorname><authormail></authormail></author><information><commentthread></commentthread><timestamp></timestamp><language></language><categories><category id="""">main</category></categories></information><text><blogtitle><![CDATA[]]></blogtitle><blogbody><![CDATA[blank]]></blogbody></text></blog>"
	Set objXMLErrorDoc = Server.CreateObject("Microsoft.XMLDOM")
	objXMLErrorDoc.async = false
	objXMLErrorDoc.setProperty "SelectionLanguage","XPath" 
	objXMLErrorDoc.loadXML(xmlString)
 	Set xmlRoot = objXMLErrorDoc.documentElement
	sXPath = "//blog"
	If strMode = "singleNode" Then
	   Set RaiseXMLError = xmlRoot.selectSingleNode(sXPath) 
	Else
		Set RaiseXMLError = xmlRoot.selectNodes(sXPath)
	End If
	Set objXMLErrorDoc = nothing
End Function

' Global Variable Declarations
Dim m_Publish_URL,m_PostID,m_BlogID,m_Admin_URL,m_Writable_URL,m_Encoding


' Main Class
Class BlogWorksObject
	Dim m_ByMonth,m_ByYear,m_ByQuantity,m_timeZone,m_timeAdjust,m_Encoding

' ***********************************************
' Property LET statements
' ***********************************************

	Public Property Let PostID(id)
		m_PostID = id
	End Property

	Public Property Let BlogID(id)
		m_BlogID = id
	End Property

	Public Property Let ByQuantity(intCount)
		m_ByQuantity = intCount
	End Property

	Public Property Let ByMonth(strMonthDigit)
		m_ByMonth = strMonthDigit
	End Property

	Public Property Let ByYear(strYearDigit)
		m_ByYear = strYearDigit
	End Property

	Public Property Let AdminURL(url)
		m_Admin_URL = cleanURL(url)
	End Property

	Public Property Let WritableURL(url)
		m_Writable_URL = cleanURL(url)
	End Property

	Public Property Let PublishURL(url)
		m_Publish_URL = cleanURL(url)
	End Property


' ***********************************************
' Property GET statements
' ***********************************************

	Public Property Get PostID
		PostID = m_PostID
	End Property

	Public Property Get CommentAPI
		If m_PostID = "" Then
			CommentAPI = false
		Else
			CommentAPI = m_Admin_URL & "incoming.asp?id=" & m_PostID
		End If
	End Property

	Public Property Get PingBackServer
		PingBackServer = m_Admin_URL & "incoming2.asp"
	End Property

	Public Property Get SinglePost
		Dim oPost
		If m_PostID = "" Then
			raiseError "The object.SinglePost method cannot be called before the PostID property is set",10
		End If
		Set m_Post = GetSinglePost(m_PostID)
 		Set oPost = New clsBlogWorksPost
		oPost.Initialize(m_Post)
		Set SinglePost = oPost
	End Property

	Public Property Get MonthsPosts
		Dim oPosts
		If m_BlogID = "" Then
			raiseError "The object.MonthsPosts method cannot be called before the BlogID property is set",20
		End If
		If m_ByMonth = "" Then
			raiseError "The object.MonthsPosts method cannot be called before the ByMonth property is set",21
		End If
		If m_ByYear = "" Then
			raiseError "The object.MonthsPosts method cannot be called before the ByYear property is set",22
		End If
		Set m_Posts = GetMonthsPosts(m_ByYear,m_ByMonth,m_BlogID)
		Set oPosts = New clsBlogWorksPosts
		oPosts.Initialize(m_Posts)
		Set MonthsPosts = oPosts
	End Property

	Public Property Get RecentPosts
		Dim oPosts
		If m_BlogID = "" Then
			raiseError "The object.RecentPosts method cannot be called before the BlogID property is set",20
		End If
		If m_ByQuantity = "" Then
			raiseError "The object.RecentPosts method cannot be called before the ByQuantity property is set",21
		End If

		Set m_Posts = GetRecentPosts(m_ByQuantity,m_BlogID)
		Set oPosts = New clsBlogWorksPosts
		oPosts.Initialize(m_Posts)
		Set RecentPosts = oPosts
	End Property


' ***********************************************
' Class Functions & Subs
' ***********************************************

  Private Function cleanURL(url)
		If right(url,1) <> "/" Then
			url = url & "/"
		End If
		
		cleanURL = url
	End Function

	Public Sub Initialize()
		If m_Writable_URL = "" Then
			raiseError "object.WritableURL property must be set",2
		End If
		If m_Admin_URL = "" Then
			raiseError "object.AdminURL property must be set",3
		End If
		If m_Publish_URL = "" Then
			raiseError "object.PublishURL property must be set",4
		End If
	m_timeAdjust = 1
	m_timeZone = 3
	End Sub

	Private Function UrlToDir(url)
		server_name = request.servervariables("SERVER_NAME")
		server_name = "http://" & server_name

		url = cleanURL(url)

		dir = right(url,len(url)-len(server_name))
		UrlToDir = dir
	End Function

	Private Function GetSinglePost(strPostID)
		If NOT isNumeric(strPostID) Then
			Set GetSinglePost = RaiseXMLError("singleNode")
			Exit Function
		End If

		Dim blogID,postYear,postMonth,postStamp,postData,dateData
		postData = DataFromPostID(strPostID)
		postStamp = postData(0)
		blogID = postData(1)

	
		dateData = TimeStampToDate(postStamp)

		validXML = XMLFileExists(dateData(0),dateData(1),blogID)
		If validXML = true Then
			Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
			objXMLDoc.async = false 
			objXMLDoc.setProperty "SelectionLanguage","XPath" 
			objXMLDoc.load(server.mappath(UrlToDir(m_Writable_URL) & dateData(0) & dateData(1) & "archive" & blogID & ".xml" ))

			Set xmlRoot = objXMLDoc.documentElement

			sXPath = "//blog[@id='" & m_PostID & "']"

			' Get the post requested and return it
			Set temp = xmlRoot.selectSingleNode(sXPath)
			If lcase(TypeName(temp)) = "nothing" Then
				Set GetSinglePost = RaiseXMLError("singleNode")
				Exit Function
			Else
				Set GetSinglePost = temp
				Exit Function
			End If
		Else
			Set GetSinglePost = RaiseXMLError("singleNode")
			Exit Function
		End If
	End Function

	Private Function GetMonthsPosts(strYear,strMonth,strBlogID)
		validXML = XMLFileExists(strYear,strMonth,strBlogID)
		If validXML = true Then
			Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
			objXMLDoc.async = false 
			objXMLDoc.setProperty "SelectionLanguage","XPath" 
			objXMLDoc.load(server.mappath(UrlToDir(m_Writable_URL) & strYear & strMonth & "archive" & strBlogID & ".xml" ))
  
			Set xmlRoot = objXMLDoc.documentElement
			sXPath = "//blog"

			Set GetMonthsPosts = xmlRoot.selectNodes(sXPath)
			Exit Function
		Else
			Set GetMonthsPosts = RaiseXMLError("multiNode")
			Exit Function
		End If
	End Function

	Private Function GetRecentPosts(strQuantity,strBlogID)
		If isNumeric(strQuantity) = false Then
			Set GetRecentPosts = RaiseXMLError("multiNode")
			Exit Function
		End If
		If strQuantity <= 0 Then
			Set GetRecentPosts = RaiseXMLError("multiNode")
			Exit Function
		End If

		set fs=Server.CreateObject("Scripting.FileSystemObject")	
		set f=fs.GetFolder(server.mappath(UrlToDir(m_Writable_URL)))
		set fo=f.files
	
		For each file in fo
			If right(file.name,14) = "archive" & strBlogID & ".xml" Then
				filestring = filestring & "#" & file.name
			End If
		Next

		set fo = nothing
		set f = nothing
		set fs = nothing
	
		If filestring = "" Then
			Set GetRecentPosts = RaiseXMLError("multiNode")
			Exit Function
		End If
	
	filestring = right(filestring,len(filestring)-1)
	filestring = trim(filestring)
	filearray = split(filestring, "#")
	filestring = trim(filestring)

	'Bubblesort the array to find highest file number
	'The idea is to have a continuous index from the array which references the appropriate
	'file name/number - held in the array.

	for x = 0 to ubound(filearray) - 1
	    for y= 0 to ubound(filearray) - 1
	        if filearray(y)>filearray(y+1) then
	            temp=filearray(y+1)
	            filearray(y+1)=filearray(y)
	            filearray(y)=temp
	        end if
	    next
	next

		' Create Receiving XML Doc
		Set objRXDoc = Server.CreateObject("Microsoft.XMLDOM")
		objRXDoc.async = false 
		Set procBlog = objRXDoc.createProcessingInstruction("xml","version=""1.0"" encoding=""ISO-8859-1""")
		objRXDoc.appendChild(procBlog)
		Set rootBlog = objRXDoc.createElement("baef")
		objRXDoc.appendChild(rootBlog)
		Set rxRoot = objRXDoc.documentElement
	
	For j = ubound(filearray) to lbound(filearray) step -1
		Set objXMLDoc = Server.CreateObject("Microsoft.XMLDOM")
		objXMLDoc.async = false 
		objXMLDoc.setProperty "SelectionLanguage","XPath" 
		objXMLDoc.load(server.mappath(UrlToDir(m_Writable_URL) & filearray(j)))
		
		Set xmlRoot = objXMLDoc.documentElement
		sXPath = "//blog"
		Set blogsxml = xmlRoot.selectNodes(sXPath)

		n_blogs = blogsxml.length
		For i = 1 to n_blogs
			Set blogxml0 = xmlRoot.selectSingleNode("//blog[" & i & "]")
			blogxmlID = blogxml0.getAttribute("id")
			Set blogxml1 = xmlRoot.selectSingleNode("//blog[" & i & "]/author")
			Set blogxml2 = xmlRoot.selectSingleNode("//blog[" & i & "]/information")
			Set blogxml3 = xmlRoot.selectSingleNode("//blog[" & i & "]/text")

			Set objNewBlog = objRXDoc.createElement("blog")
			objNewBlog.setAttribute "id", blogxmlID
			rxRoot.appendChild(objNewBlog)

			objNewBlog.appendChild(blogxml1)
			objNewBlog.appendChild(blogxml2)
			objNewBlog.appendChild(blogxml3)

			Set countTest = objRXDoc.selectNodes(sXPath)

			If countTest.length = CInt(strQuantity) Then
					StopThing = true
					Exit For
			End If
			
		Next

		If StopThing = true Then
			Exit For
		End If
			Set objXMLDoc = nothing
	Next

	Set GetRecentPosts = objRXDoc.selectNodes(sXPath)
	End Function

	Private Function XMLFileExists(strYear,strMonth,strBlogID)
		Set fso = CreateObject("Scripting.FileSystemObject")
		If fso.fileExists(server.mappath(UrlToDir(m_Writable_URL) & strYear & strMonth & "archive" & strBlogID & ".xml" )) Then
			Set fso = nothing
			XMLFileExists = true
		Else
			Set fso = nothing
			XMLFileExists = false
		End If
	End Function

End Class


' ***********************************************
' Sub classes for posts
' ***********************************************
Class clsBlogWorksPosts
	Private m_Posts
	
	Public Sub Initialize(oNodeList)
		Set m_Posts = oNodeList
	End Sub
	
	Public Property Get Count
	  Count = m_Posts.Length
	End Property

	Private Function checkState()
		set m_Post = m_Posts.item(0)
		postID = m_Post.getAttribute("id") 
		If postID <> "" Then
			checkState = true
		Else
			checkSate = false
		End If
	End Function

	Public Property Get isEmpty
		If checkState() = true Then
			isEmpty = false
		Else
			isEmpty = true
		End If
	End Property

	Public Property Get Post(index)
		Dim oPost
		Set oPost = New clsBlogWorksPost

		' First, pass the correct node to the class
		oPost.Initialize m_Posts.item(index)
				
		' Then, send the class to the caller
		Set Post = oPost
	End Property
End Class


Class clsBlogWorksPost
	Dim m_Post,postID

	Public Sub Initialize(oNode)
		Set m_Post = oNode
	End Sub

	Public Property Get AuthorName
		AuthorName = m_Post.selectSingleNode("author/authorname").text
	End Property

	Public Property Get AuthorMail
		AuthorMail = m_Post.selectSingleNode("author/authormail").text
	End Property

	Public Property Get Language
		Language = m_Post.selectSingleNode("information/language").text
	End Property

	Public Property Get Title
		Title = m_Post.selectSingleNode("text/blogtitle").text
	End Property

	Public Property Get Body
		Body = m_Post.selectSingleNode("text/blogbody").text
	End Property
	
'	Public Property Get pid()
'	  pid = m_Post.getAttribute("id")
'	End Property

	Private Function checkState
		postID = m_Post.getAttribute("id") 
		If postID <> "" Then
			checkState = true
		Else
			checkSate = false
		End If
	End Function

	Private Function GetPostInfo(intIndex)
		Dim dataArray(7)	
		postID = m_Post.getAttribute("id")
		postData = DataFromPostID(postID)
		dataArray(0) = postData(0)	'postStamp
		dataArray(1) = postData(1)	'blogID

		dateData = TimeStampToDate(dataArray(0))
		dataArray(2) = dateData(0) 	'Year
		dataArray(3) = dateData(1) 	'Month
		dataArray(4) = dateData(2) 	'Day
		dataArray(5) = dateData(3) 	'Hour
		dataArray(6) = dateData(4) 	'Minute
		dataArray(7) = dateData(5) 	'Second
    
		GetPostInfo = dataArray(intIndex)
	End Function

	Public Property Get Year
		If checkState() = true Then
			Year = GetPostInfo(2)
		Else
			Year = ""
		End If
	End Property

	Public Property Get Month
		If checkState() = true Then
			Month = GetPostInfo(3)
		Else
			Month = ""
		End If
	End Property

	Public Property Get Day
		If checkState() = true Then
			Day = GetPostInfo(4)
		Else
			Day = ""
		End If
	End Property

	Public Property Get Hour
		If checkState() = true Then
			Hour = GetPostInfo(5)
		Else
			Hour = ""
		End If
	End Property

	Public Property Get Minute
		If checkState() = true Then
			Minute = GetPostInfo(6)
		Else
			Minute = ""
		End If
	End Property

	Public Property Get Second
		If checkState() = true Then
			Second = GetPostInfo(7)
		Else
			Second = ""
		End If
	End Property

	Public Property Get Date
		If checkState = true Then
			Date = GetPostInfo(2) & "/" & GetPostInfo(3) & "/" & GetPostInfo(4)
		Else
			Date = ""
		End If
	End Property

	Public Property Get Time
		If checkState() = true Then
			Time = GetPostInfo(5) & ":" & GetPostInfo(6) & ":" & GetPostInfo(7)
		Else
			Time = ""
		End If
	End Property
	
	Public Property Get TimeOffset
		If checkState() = true Then
			TimeOffset = "12"
		Else
			TimeOffset = ""
		End If
	End Property
	
	Public Property Get PermaLink
		If checkState() = true Then
  			PermaLink = m_Publish_URL & GetPostInfo(2) & GetPostInfo(3) & "archive" & GetPostInfo(1) & ".asp#" & GetPostInfo(0) & GetPostInfo(1)
		Else
			Permalink = ""
		End If
	End Property

	Public Property Get isEmpty
		If checkState() = true Then
			isEmpty = false
		Else
			isEmpty = true
		End If
	End Property

	Public Property Get GetComments
		Set m_TB = Server.CreateObject("Microsoft.XMLDOM")
		m_TB.setProperty "SelectionLanguage","XPath" 
		m_TB.load (server.mappath(UrlToDir(m_Writable_URL) & "incoming/rx" & postID & ".xml"))

		Dim oPings
		
		' Get the Pings collection
		Dim sXPath
		sXPath = "//item"
		Set m_Pings = m_TB.selectNodes(sXPath)

		Set oPings = New clsCommentAPIItems
		oPings.Initialize(m_Pings)
		Set GetComments = oPings
	End Property
End Class


' ***********************************************
' Comments Class + sub classes
' ***********************************************
Class CommentObject
	Public Sub Initialize()
		If m_Writable_URL = "" Then
			raiseError "object.WritableURL property must be set",1
		End If
		If m_PostID = "" Then
			raiseError "object.PostID property must be set",2
		End If
	End Sub

	Private Function cleanURL(url)
		If right(url,1) <> "/" Then
			url = url & "/"
		End If
		
		cleanURL = url
	End Function

	Private Function UrlToDir(url)
		server_name = request.servervariables("SERVER_NAME")
		server_name = "http://" & server_name

		url = cleanURL(url)

		dir = right(url,len(url)-len(server_name))
		UrlToDir = dir
	End Function

	Public Property Let PostID(id)
		m_PostID = id
	End Property

	Public Property Let WritableURL(url)
		m_Writable_URL = cleanURL(url)
	End Property

	Public Property Get GetComments
		Set m_TB = Server.CreateObject("Microsoft.XMLDOM")
		m_TB.setProperty "SelectionLanguage","XPath" 
		m_TB.load (server.mappath(UrlToDir(m_Writable_URL) & "incoming/rx" & m_PostID & ".xml"))

		Dim oPings
		
		' Get the Pings collection
		Dim sXPath
		sXPath = "//item"
		Set m_Pings = m_TB.selectNodes(sXPath)

		Set oPings = New clsCommentAPIItems
		oPings.Initialize(m_Pings)
		Set GetComments = oPings
	End Property
End Class


Class clsCommentAPIItems
	Private m_Pings
	
	Public Sub Initialize(oNodeList)
		Set m_Pings = oNodeList
	End Sub
	
	Public Property Get Count
		Count = m_Pings.Length 
	End Property

	Public Property Get Item(index)
		Dim oPing
		Set oPing = New clsCommentAPISingleItem

		' First, pass the correct node to the class
		oPing.Initialize m_Pings.item(index)
				
		' Then, send the class to the caller
		Set Item = oPing
	End Property
End Class


Class clsCommentAPISingleItem
	Dim m_Ping

	Public Sub Initialize(oNode)
		Set m_Ping = oNode
	End Sub

	Private Function NodeCheck(named_node,node_list)
		set m_Ping_list = node_list.selectNodes("*")
		stopFlag = false
		For Each Node In m_Ping_list
			If Node.nodeName = named_node Then
				stopFlag = true
				Exit For
			End If
		Next
		set m_Ping_list = nothing
		If stopFlag = true Then
			intern = m_Ping.selectSingleNode(named_node).text
		Else
			intern = ""
		End If
		stopFlag = false
		NodeCheck = intern
	End Function

	Private Function SplitPubDate(pubDate,intIndex)
	dArray = split(pubDate," ")
	tArray = split(dArray(4),":")

		Dim dataArray(6)	
		dataArray(0) = dArray(3)	'Year
		dataArray(1) = MonthToDigit(dArray(2))	'Month
		dataArray(2) = dArray(1) 	'Day
		dataArray(3) = tArray(0) 	'Hour
		dataArray(4) = tArray(1) 	'Minute
		dataArray(5) = tArray(2) 	'Second
		dataArray(6) = "GMT/UTC"	'Timezone
    
		SplitPubDate = dataArray(intIndex)
	End Function

	Private Function MonthToDigit(strMonth)
		Select Case lcase(strMonth)
			Case "jan"
				intMonth = "01"
			Case "feb"
				intMonth = "02"
			Case "mar"
				intMonth = "03"
			Case "apr"
				intMonth = "04"
			Case "may"
				intMonth = "05"
			Case "jun"
				intMonth = "06"
			Case "jul"
				intMonth = "07"
			Case "aug"
				intMonth = "08"
			Case "sep"
				intMonth = "09"
			Case "oct"
				intMonth = "10"
			Case "nov"
				intMonth = "11"
			Case "dec"
				intMonth = "12"
		End Select
		MonthToDigit = intMonth
	End Function
	
	Public Property Get Time
		Time = SplitPubDate(NodeCheck("pubDate",m_Ping),3) & ":" & SplitPubDate(NodeCheck("pubDate",m_Ping),4) & ":" & SplitPubDate(NodeCheck("pubDate",m_Ping),5) 
	End Property

	Public Property Get Date
		Date = SplitPubDate(NodeCheck("pubDate",m_Ping),0) & "/" & SplitPubDate(NodeCheck("pubDate",m_Ping),1) & "/" & SplitPubDate(NodeCheck("pubDate",m_Ping),2) 
	End Property

	Public Property Get Year
		Year = SplitPubDate(NodeCheck("pubDate",m_Ping),0)
	End Property

	Public Property Get Month
		Month = SplitPubDate(NodeCheck("pubDate",m_Ping),1)
	End Property

	Public Property Get Day
		Day = SplitPubDate(NodeCheck("pubDate",m_Ping),2)
	End Property

	Public Property Get Hour
		Hour = SplitPubDate(NodeCheck("pubDate",m_Ping),3)
	End Property

	Public Property Get Minute
		Minute = SplitPubDate(NodeCheck("pubDate",m_Ping),4)
	End Property

	Public Property Get Second
		Second = SplitPubDate(NodeCheck("pubDate",m_Ping),5)
	End Property

	Public Property Get TimeZone
		TimeZone = SplitPubDate(NodeCheck("pubDate",m_Ping),6)
	End Property

	Public Property Get GUID
		GUID = NodeCheck("guid",m_Ping)
	End Property
	
	Public Property Get Link
		Link = NodeCheck("link",m_Ping)
	End Property

	Public Property Get Title()
		Title = NodeCheck("title",m_Ping)
	End Property

	Public Property Get Source
		Source = NodeCheck("source",m_Ping)
	End Property

	Public Property Get AuthorName
		tAuthor = NodeCheck("author",m_Ping)
		If inStr(tAuthor,"(") Then
			AuthorName = left(tAuthor,instr(tAuthor,"(")-2)
		Else
			AuthorName = tAuthor
		End If
	End Property

	Public Property Get AuthorMail
		tAuthor = NodeCheck("author",m_Ping)
		If inStr(tAuthor,"(") Then
			tAuthor = right(tAuthor,len(tAuthor) - instr(tAuthor,"("))
			tAuthor = left(tAuthor,len(tAuthor)-1)
			AuthorMail = tAuthor
		Else
			AuthorMail = ""
		End If
	End Property

	Public Property Get Body
		Body = NodeCheck("description",m_Ping)
	End Property

	Public Property Get ItemType
		ItemType = NodeCheck("category",m_Ping)
	End Property

End Class
%>