<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<!-- #include file="text_filter.asp" -->
<%
Dim usedTemplate,temp_mode,strTemplate,bpostid,bdatetime,bauthorname,bauthoremail,bcommentthread,btitle,bbody,uTemplate,currentDate,nextDate,alist,archive_file,last_title,bcatID,bcatName,bCatNameGbl

If server_port <> "" Then
	'find first /
	first_slash = InStr(publish_url,"/")
	l_pub = left(publish_url,first_slash-1)
	r_pub = right(publish_url,len(publish_url)-first_slash)
	publish_url = l_pub & ":" & server_port & "/" & r_pub
End If


' ****************************************
' 
' Generate Category List & PreProcess Template to extract category ID
'
' ****************************************

Function PreProcessTemplate(strTemplate)
	If InStr(strTemplate,"[+blog category=""") Then
		Dim regEx, Match, Matches 
		Set regEx = New RegExp
		regEx.Pattern = "\[\+blog category=""(.*?)""\]" 
		regEx.IgnoreCase = True
		regEx.Global = True
		Set Matches = regEx.Execute(strTemplate)
		strOutput = Matches(0).subMatches(0)
		Set regEx = nothing
	Else
		strOutput = ""
	End If

	bCatNameGbl = GetCategoryFromID(blog_id,strOutput)

	PreProcessTemplate = strOutput
End Function


Function ProcessCatList(strTemplate)
	If InStr(strTemplate,"[categorylist separator=""") Then
		Dim regEx,Matches 
		Set regEx = New RegExp
		regEx.Pattern = "\[categorylist separator=""(.*?)""\]" 
		regEx.IgnoreCase = True
		regEx.Global = True
		Set Matches = regEx.Execute(strTemplate)
		strSep = Matches(0).subMatches(0)
		Set regEx = nothing

		' read XML file:
		Set catList = listNodes(blog_id,"category","categories.xml")

		If catList.length = 0 Then
			strCat = ""
		Else
			For Each Item in catList
				catName = Item.selectSingleNode("name").text
				catID = Item.selectSingleNode("id").text
				catFileName = Item.selectSingleNode("filename").text
				If CheckFileExists(publish_dir & catFileName) = true Then
					strCat = strCat & "<a href=""" & publish_url & catFileName & """>" & catName & "</a>" & strSep
				Else
					strCat = strCat
				End If
			Next
		
		Set catList = nothing

		End If

		Set regEx = New RegExp
		regEx.Pattern = "\[categorylist separator="".*?""\]" 
		regEx.IgnoreCase = True
		regEx.Global = True
		strOutput = regEx.Replace(strTemplate,strCat)
		Set regEx = nothing
	Else
		strOutput = strTemplate
	End If

ProcessCatList = strOutput
End Function


' ****************************************
' 
' Generate Archive List
'
' ****************************************
Function ArchiveList(blogID,lastMonth)
'Find all archive files related to blog id:
set fs=Server.CreateObject("Scripting.FileSystemObject")

If fs.FolderExists(Server.MapPath(writable_dir)) = true Then
	set f=fs.GetFolder(Server.MapPath(writable_dir))
	set fo=f.files

	For each file in fo
		If right(file.name,14) = "archive" & blogID & ".xml" Then
			stringlist = stringlist & "#" & file.name
		End If
	Next

	stringlist = right(stringlist,len(stringlist)-1)
	filearray = split(stringlist,"#")

	for x = 0 to ubound(filearray) - 1
		for y= 0 to ubound(filearray) - 1
			if filearray(y)>filearray(y+1) then
				temp=filearray(y+1)
				filearray(y+1)=filearray(y)
				filearray(y)=temp
			end if
		next
	next

	If lastMonth = True Then
		ArchiveList = filearray(ubound(filearray))
		Exit Function
	End If

	For i = ubound(filearray) to lbound(filearray) step -1
		archive_file = left(filearray(i),(len(filearray(i))-4)) & archive_ext
		outstring = outstring & "<a href=""" & publish_url & archive_file & """ class=""archivelist"">" & 					ProcessArchiveDate(left(filearray(i),6),archive_date_format) & "</a><br />"
		archive_file = ""
	Next

	set fo = nothing
	set f = nothing
End If

set fs = nothing
ArchiveList = outstring
End Function




' ****************************************
' 
' Main Template Process
'
' ****************************************
  
Sub ProcessMidTemplate(mode)

' Blogger mode
If mode = "blogger" Then
	uTemplate = replace(strTemplate,"<$BlogItemNumber$>",bpostid & blog_id)
	
	If nextDate = currentDate Then
		uTemplate = replace(uTemplate,"<BlogDateHeader>","<!--dh")
		uTemplate = replace(uTemplate,"</BlogDateHeader>","dh-->")
	Else
		uTemplate = replace(uTemplate,"<BlogDateHeader>","")
		uTemplate = replace(uTemplate,"</BlogDateHeader>","")
	End If

	uTemplate = replace(uTemplate,"<$BlogDateHeaderDate$>",ProcessDate(bdatetime,date_format))
	uTemplate = replace(uTemplate,"<$BlogItemDateTime$>",ProcessTime(bdatetime,time_format))
	uTemplate = replace(uTemplate,"<$BlogItemAuthor$>",first_name & " " & last_name)
	uTemplate = replace(uTemplate,"<$BlogItemAuthorNickname$>",bauthorname)
	uTemplate = replace(uTemplate,"<$BlogItemAuthorEmail$>",e_mail)
	uTemplate = replace(uTemplate,"<$BlogItemAuthorURL$>",publish_url & blog_main_file)
	uTemplate = replace(uTemplate,"<$BlogItemBody$>",filterText(bbody,"p","post",""))
	uTemplate = replace(uTemplate,"<$BlogItemArchiveFileName$>",publish_url & archive_index_file)
	uTemplate = replace(uTemplate,"<$BlogItemURL$>",publish_url & left(bdatetime,6) & "archive" & blog_id & ".asp#" & bpostid)
	uTemplate = replace(uTemplate,"<$BlogArchiveLink$>",publish_url & archive_file)
	uTemplate = replace(uTemplate,"<$BlogArchiveName$>",ProcessArchiveDate(left(archive_file,6),archive_date_format))
	uTemplate = replace(uTemplate,"<Blogger>","")
	uTemplate = replace(uTemplate,"</Blogger>","")

' BigBlogTool mode
ElseIf mode = "bbt" Then
	uTemplate = replace(strTemplate,"/.blogid",bpostid & blog_id)

	If nextDate = currentDate Then
		uTemplate = replace(uTemplate,"/.dateheader","")
	Else
		uTemplate = replace(uTemplate,"/.dateheader",ProcessDate(bdatetime,date_format))
	End If
	
	uTemplate = replace(uTemplate,"/.timestamp",ProcessTime(bdatetime,time_format))
	uTemplate = replace(uTemplate,"/.postedby",bauthorname)
	uTemplate = replace(uTemplate,"/.body",filterText(bbody,"p","post",""))
	uTemplate = replace(uTemplate,"/.head",btitle)
	uTemplate = replace(uTemplate,"/.link",publish_url & left(bdatetime,6) & "archive" & blog_id & ".asp#" & bpostid & blog_id)
	uTemplate = replace(uTemplate,"/.archivelist",alist)
	uTemplate = replace(uTemplate,"/.startmainblog","")
	uTemplate = replace(uTemplate,"/.endmainblog","")
End If

' BlogWorks XML Tags 
uTemplate = replace(strTemplate,"[postid]",bpostid & blog_id)

If nextDate = currentDate Then
	uTemplate = replace(uTemplate,"[+dateheader]","<!--dh")
	uTemplate = replace(uTemplate,"[-dateheader]","dh-->")
Else
	uTemplate = replace(uTemplate,"[+dateheader]","")
	uTemplate = replace(uTemplate,"[-dateheader]","")
End If

' Title headers
If btitle = "" Then
	uTemplate = replace(uTemplate,"[+title]","<!--title")
	uTemplate = replace(uTemplate,"[-title]","title-->")
Else
	uTemplate = replace(uTemplate,"[+title]","")
	uTemplate = replace(uTemplate,"[-title]","")
End If

' Time and Date
uTemplate = replace(uTemplate,"[date]",ProcessDate(bdatetime,date_format))
uTemplate = replace(uTemplate,"[time]",ProcessTime(bdatetime,time_format))

' Author Information
uTemplate = replace(uTemplate,"[authorname]",first_name & " " & last_name)
uTemplate = replace(uTemplate,"[authornickname]",bauthorname)
uTemplate = replace(uTemplate,"[authormail]",e_mail)
uTemplate = replace(uTemplate,"[authoremail]",e_mail)

' Blog main page URL
uTemplate = replace(uTemplate,"[blogurl]",publish_url & blog_main_file)
uTemplate = replace(uTemplate,"[bloglanguage]",blog_lang)

' The  post itself
uTemplate = replace(uTemplate,"[title]",entityEncodeNonHTML(btitle))
uTemplate = replace(uTemplate,"[body]",filterText(bbody,"p","post",""))
uTemplate = replace(uTemplate,"[posturl]",publish_url & left(bdatetime,6) & "archive" & blog_id & archive_ext & "#" & bpostid & blog_id)
uTemplate = replace(uTemplate,"[category]",bcatName)

' Syndication
filteredBody = filterText(bbody,"p","","")

uTemplate = replace(uTemplate,"[syndicate:body mode=""raw""]",bbody)
uTemplate = replace(uTemplate,"[syndicate:body mode=""stripped""]",stripHTML(bbody,true))
uTemplate = replace(uTemplate,"[syndicate:body mode=""escaped""]",entityEncode(filteredBody))
uTemplate = replace(uTemplate,"[syndicate:body mode=""cdata""]","<![CDATA[" & filteredBody & "]]>")
uTemplate = replace(uTemplate,"[syndicate:body mode=""xhtml""]",filteredBody)

uTemplate = replace(uTemplate,"[syndicate:title]",stripHTML(btitle,true))
uTemplate = replace(uTemplate,"[syndicate:title mode=""raw""]",btitle)
uTemplate = replace(uTemplate,"[syndicate:title mode=""stripped""]",stripHTML(btitle,true))
uTemplate = replace(uTemplate,"[syndicate:title mode=""escaped""]",entityEncode(stripHTML(btitle,true)))


uTemplate = replace(uTemplate,"[syndicate:date format=""iso8601""]",UnixToRSS(HumanToUnix(bdatetime),"iso8601"))
uTemplate = replace(uTemplate,"[syndicate:date format=""rfc822""]",UnixToRSS(HumanToUnix(bdatetime),"rfc822"))

uTemplate = replace(uTemplate,"[rss:description]",entityEncode(filteredBody))
uTemplate = replace(uTemplate,"[rss:title]",entityEncode(stripHTML(btitle,true)))
uTemplate = replace(uTemplate,"[rss:pubdate]",UnixToRSS(HumanToUnix(bdatetime),"rfc822"))


' Archiving Information
uTemplate = replace(uTemplate,"[archiveindex]",publish_url & archive_index_file)
uTemplate = replace(uTemplate,"[archivelist]",alist)

' Comment Thread ID
uTemplate = replace(uTemplate,"[commentthread]",bcommentthread)

' Last available post title
uTemplate = replace(uTemplate,"[lasttitle]",entityEncodeNonHTML(last_title))

' URL of Image directory
uTemplate = replace(uTemplate,"[imageurl]",images_url)

' TrackBack
If comment_rdf = "yes" Then
	c_rdf_open = "<!--" & vbCrLf
	c_rdf_close = vbCrLf & "-->"
Else
	c_rdf_open = ""
	c_rdf_close = ""
End If

built_rdf = vbCrLf & c_rdf_open & "<rdf:RDF xmlns:rdf=""http://www.w3.org/1999/02/22-rdf-syntax-ns#""" & vbCrLf
built_rdf = built_rdf & vbTab & "xmlns:dc=""http://purl.org/dc/elements/1.1/""" & vbCrLf
built_rdf = built_rdf & vbTab & "xmlns:trackback=""http://madskills.com/public/xml/rss/module/trackback/"">" & vbCrLf
built_rdf = built_rdf & "<rdf:Description" & vbCrLf
built_rdf = built_rdf & vbTab & "rdf:about=""" & publish_url & left(bdatetime,6) & "archive" & blog_id & archive_ext & "#" & bpostid & blog_id & """" & vbCrLf
built_rdf = built_rdf & vbTab & "dc:identifer=""" & publish_url & left(bdatetime,6) & "archive" & blog_id & archive_ext & "#" & bpostid & blog_id & """" & vbCrLf
built_rdf = built_rdf & vbTab & "dc:title=""" & entityEncode(btitle) & """" & vbCrLf
built_rdf = built_rdf & vbTab & "trackback:ping=""" & admin_url & "incoming.asp?id=" & bpostid & blog_id & """" & " />" & vbCrLf
built_rdf = built_rdf & "</rdf:RDF>" & c_rdf_close & vbCrLf

uTemplate = replace(uTemplate,"[tb:rdf]",built_rdf)
uTemplate = replace(uTemplate,"[tb:url]", admin_url & "incoming.asp?id=" & bpostid & blog_id)
uTemplate = replace(uTemplate,"[tb:displayurl]",admin_url & "rx_display.asp?id=" & bpostid & blog_id)
uTemplate = replace(uTemplate,"[rx:url]", admin_url & "incoming.asp?id=" & bpostid & blog_id)
uTemplate = replace(uTemplate,"[rx:displayurl]",admin_url & "rx_display.asp?id=" & bpostid & blog_id)

' Main Blog tags
uTemplate = replace(uTemplate,"[+blog]","")
uTemplate = replace(uTemplate,"[-blog]","")

' RegExp to remove commented DateHeader tags to clean up the output a bit. 
' Thanks for the idea to Ben at http://www.blogtastic.com

	Dim regEx, Match, Matches 
	Set regEx = New RegExp
	regEx.Pattern = "<!--dh.*(.|\n)*?dh-->" 
	regEx.IgnoreCase = True
	regEx.Global = True
	uTemplate = regEx.Replace(uTemplate, "")
	Set regEx = nothing

	Set regEx = New RegExp
	regEx.Pattern = "<!--title.*(.|\n)*?title-->" 
	regEx.IgnoreCase = True
	regEx.Global = True
	uTemplate = regEx.Replace(uTemplate, "")
	Set regEx = nothing

	Set regEx = New RegExp
	regEx.Pattern = "\[\+blog category="".*?""\]" 
	regEx.IgnoreCase = True
	regEx.Global = True
	uTemplate = regEx.Replace(uTemplate, "")
	Set regEx = nothing
End Sub



' ****************************************
' 
' Process top and bottom parts of template
'
' ****************************************

Public Function ProcessOuterTemplate(mode,ttype,position)
Dim uTemplate
If position="top" Then
	uTemplate = ReadTemplate(ttype,true,false,false,blog_id)
ElseIf position = "bottom" Then
	uTemplate = ReadTemplate(ttype,false,false,true,blog_id)
End If

If mode = "blogger" Then
	uTemplate = replace(uTemplate,"<$BlogTitle$>",blog_name)
	uTemplate = replace(uTemplate,"<$BlogDescription$>",blog_desc)
	uTemplate = replace(uTemplate,"<$BlogArchiveFileName$>",publish_url & archive_index_file)
End If

If mode = "bbt" Then
	uTemplate = replace(uTemplate,"/.blogname",blog_name)
	uTemplate = replace(uTemplate,"/.blogdescription",blog_desc)
	uTemplate = replace(uTemplate,"/.archivelist",alist)
End If

' Blog Information
uTemplate = replace(uTemplate,"[blogname]",blog_name)
uTemplate = replace(uTemplate,"[blogdescription]",blog_desc)
uTemplate = replace(uTemplate,"[bloglanguage]",blog_lang)
uTemplate = replace(uTemplate,"[blogurl]",publish_url & blog_main_file)
uTemplate = replace(uTemplate,"[blogencoding]",encode_as)
uTemplate = replace(uTemplate,"[category]",bCatNameGbl)

' Author Information
uTemplate = replace(uTemplate,"[authorname]",first_name & " " & last_name)
uTemplate = replace(uTemplate,"[authornickname]",bauthorname)
uTemplate = replace(uTemplate,"[authormail]",e_mail)
uTemplate = replace(uTemplate,"[authoremail]",e_mail)

' Syndication
uTemplate = replace(uTemplate,"[rss:lastbuilddate]",UnixToRSS(HumanToUnix(""),"rfc822"))
uTemplate = replace(uTemplate,"[syndicate:lastbuilddate format=""iso8601""]",UnixToRSS(HumanToUnix(""),"iso8601"))
uTemplate = replace(uTemplate,"[syndicate:lastbuilddate format=""rfc822""]",UnixToRSS(HumanToUnix(""),"rfc822"))
uTemplate = replace(uTemplate,"[syndicate:lastmodified format=""iso8601""]",UnixToRSS(HumanToUnix(""),"iso8601"))
uTemplate = replace(uTemplate,"[syndicate:lastmodified format=""rfc822""]",UnixToRSS(HumanToUnix(""),"rfc822"))
Set feedList = listNodes(blog_id,"feed","syndication.xml")
For Each Item in feedList
	feedName = Item.selectSingleNode("name").text
	feedFileName = Item.selectSingleNode("filename").text
uTemplate = replace(uTemplate,"[syndicate:feed name=""" & feedName & """]",publish_url & feedFileName)
Next
Set feedList = nothing


' Archive List
uTemplate = replace(uTemplate,"[archivelist]",alist)

' Last available post title
uTemplate = replace(uTemplate,"[lasttitle]",entityEncodeNonHTML(last_title))

' Created With BlogWorks link
uTemplate = replace(uTemplate,"[createdwith]","<a href=""http://www.blogworks.com"" target=""_blank"" class=""createdwithBW"">BlogWorks <small>XML</small> [version]</a>")

' Created With BlogWorks link + image
uTemplate = replace(uTemplate,"[image:createdwith]","<a href=""http://www.blogworks.com"" target=""_blank"" class=""createdwithBW""><img src=""[imageurl]bwxml.gif"" alt=""Created with BlogWorks XML [version]"" width=""80"" height=""31"" border=""0"" /></a>")

' Image URL
uTemplate = replace(uTemplate,"[imageurl]",images_url)

' Include for RX scripts
uTemplate = replace(uTemplate,"[rx:include]","<!-- #include file=""" & admin_rel & "rx_inc.asp"" -->")

' Include for paths.asp file also exists as [api:paths]
uTemplate = replace(uTemplate,"[rx:paths]","<!-- #include file=""" & admin_rel & "paths.asp"" -->")

' Script for X-Pingback HTTP Header additon and link
uTemplate = replace(uTemplate,"[pb:header]", Chr(60) & "% Response.AddHeader ""X-Pingback"", """ & admin_url & "incoming2.asp"" %" & Chr(62))
uTemplate = replace(uTemplate,"[pb:server]",admin_url & "incoming2.asp")

' API tags
uTemplate = replace(uTemplate,"[api:blogid]", Chr(60) & "%" & vbCrLf & "Dim blogID" & vbCrLf & "blogID = ""[blogid]""" & vbCrLf & "%" & Chr(62))
uTemplate = replace(uTemplate,"[api:include]","<!-- #include file=""" & admin_rel & "bw_api.asp"" -->")
uTemplate = replace(uTemplate,"[api:paths]","<!-- #include file=""" & admin_rel & "paths.asp"" -->")

' BlogWorks Version Info
uTemplate = replace(uTemplate,"[version]",bw_release)

' Blog ID number
uTemplate = replace(uTemplate,"[blogid]", blog_id)

' Javascript for pop-up windows
built_script = "<script language=""javascript"" type=""text/javascript"">" & vbCrLf
built_script = built_script & "function OpenWindow (url) {" & vbCrLf
built_script = built_script & "window.open(url,'rx','width=550,height=480,scrollbars=yes,status=yes');" & vbCrLf
built_script = built_script & "}" & vbCrLf
built_script = built_script & "</script>" & vbCrLf
uTemplate = replace(uTemplate,"[rx:script]",built_script)


ProcessOuterTemplate = uTemplate
uTemplate = ""
End Function


' ****************************************
' 
' Process Main Blog Page
'
' ****************************************

'Publish Main Blog Page
Sub PublishMainPage(blogid,mainfilename)


strTemplate = ReadTemplate("main",false,true,false,blogid)

If InStr(1, strTemplate,"[+blog") Then
	temp_mode = "bwxml"
	alist = ArchiveList(blogid,false)
ElseIf InStr(1, strTemplate,"/.startmainblog") Then
	temp_mode = "bbt"
	alist = ArchiveList(blogid,false)
ElseIf InStr(1, strTemplate,"<Blogger>") Then
	temp_mode = "blogger"
End If

nextDate = ""

set respLastTitle = GetMultiplePosts("1",true,false,blog_id,"all")
last_title = respLastTitle.fields(7)
set respLastTitle = nothing

set resp = GetMultiplePosts(per_page,true,false,blogid,"all")
Do While Not resp.EOF
	bdatetime = resp.fields(1)
	bpostid = resp.fields(2)
	bpostid = ExtractTimestamp(bpostid)
	bauthorname = resp.fields(3)
	bauthormail = resp.fields(4)
	bcommentthread = resp.fields(5)
	btitle = resp.fields(7)
	bbody = resp.fields(8)
	bcatID = resp.fields(10)
	bcatName = resp.fields(11)
	
	currentDate = left(UnixToHuman(bpostid),8)

	ProcessMidTemplate temp_mode

	resp.MoveNext
	nextDate = currentDate
	outString = outString & uTemplate
Loop

topTemplate = ProcessOuterTemplate(temp_mode,"main","top")
bottomTemplate = ProcessOuterTemplate(temp_mode,"main","bottom")

fullTemplate = ProcessCatList(topTemplate & outString & bottomTemplate)
'fullTemplate = (topTemplate & outString & bottomTemplate)

set fileObj = Server.CreateObject("Scripting.FileSystemObject")
fname = (server.mappath(publish_dir & mainfilename))

set txtfile = fileObj.CreateTextFile(fname,true)
	txtfile.write fullTemplate
	txtfile.close
set txtfile = nothing

set fileObj =nothing
uTemplate = ""
outString = ""
End Sub

' ****************************************
' 
' Process Category Page
'
' ****************************************

Sub PublishCategoryPage(byVal blogid,byVal categoryFileName,byVal categoryTemplateAlias)


strTemplate = ReadTemplate(categoryTemplateAlias,false,true,false,blogid)

If InStr(1, strTemplate,"[+blog") Then
	temp_mode = "bwxml"
	alist = ArchiveList(blogid,false)
ElseIf InStr(1, strTemplate,"/.startmainblog") Then
	temp_mode = "bbt"
	alist = ArchiveList(blogid,false)
ElseIf InStr(1, strTemplate,"<Blogger>") Then
	temp_mode = "blogger"
End If

nextDate = ""

readCategory = PreProcessTemplate(strTemplate)

On Error Resume Next
set respLastTitle = GetMultiplePosts("1",true,false,blog_id,readCategory)
If Err <> 0 Then
	Exit Sub
End If
last_title = respLastTitle.fields(7)
set respLastTitle = nothing

set resp = GetMultiplePosts(per_page,true,false,blogid,readCategory)
Do While Not resp.EOF
	bdatetime = resp.fields(1)
	bpostid = resp.fields(2)
	bpostid = ExtractTimestamp(bpostid)
	bauthorname = resp.fields(3)
	bauthormail = resp.fields(4)
	bcommentthread = resp.fields(5)
	btitle = resp.fields(7)
	bbody = resp.fields(8)
	bcatID = resp.fields(10)
	bcatName = resp.fields(11)
	
	currentDate = left(UnixToHuman(bpostid),8)

	ProcessMidTemplate temp_mode

	resp.MoveNext
	nextDate = currentDate
	outString = outString & uTemplate
Loop

topTemplate = ProcessOuterTemplate(temp_mode,categoryTemplateAlias,"top")
bottomTemplate = ProcessOuterTemplate(temp_mode,categoryTemplateAlias,"bottom")

fullTemplate = ProcessCatList(topTemplate & outString & bottomTemplate)

set fileObj = Server.CreateObject("Scripting.FileSystemObject")
fname = (server.mappath(publish_dir & categoryFileName))

set txtfile = fileObj.CreateTextFile(fname,true)
	txtfile.write fullTemplate
	txtfile.close
set txtfile = nothing

set fileObj =nothing
uTemplate = ""
outString = ""
End Sub


' ****************************************
' 
' Process Most Recent, this month's Archive Page
'
' ********************


Sub PublishRecentArchive(blogid)
Dim archive_file

a_filename = ArchiveList(blog_id,true)

set respLastTitle = GetMultiplePosts("1",true,false,blog_id,"all")
last_title = respLastTitle.fields(7)
set respLastTitle = nothing

'number_of_posts,ext,blogid

strTemplate = ReadTemplate("archivePages",false,true,false,blogid)

archive_file = left(a_filename,len(a_filename)-4) & archive_ext

If InStr(1, strTemplate,"<Blogger>") Then
	temp_mode = "blogger"
End If

If InStr(strTemplate,"/.startmainblog") Then

		alist = ArchiveList(blogid,false)

	temp_mode = "bbt"
End If

If InStr(strTemplate,"[+blog") Then

		alist = ArchiveList(blogid,false)

	temp_mode = "bwxml"
End If

nextDate = ""
set resp = GetMonthsPosts(a_filename,true,blogid)
Do While Not resp.EOF
	bdatetime = resp.fields(1)
	bpostid = resp.fields(2)
	bpostid = ExtractTimestamp(bpostid)
	bauthorname = resp.fields(3)
	bauthormail = resp.fields(4)
	bcommentthread = resp.fields(5)
	btitle = resp.fields(7)
	bbody = resp.fields(8)
	bcatID = resp.fields(10)
	bcatName = resp.fields(11)

	currentDate = left(UnixToHuman(bpostid),8)

	ProcessMidTemplate temp_mode
	resp.MoveNext
	nextDate = currentDate

	outString = outString & uTemplate
Loop

topTemplate = ProcessOuterTemplate(temp_mode,"archivePages","top")
bottomTemplate = ProcessOuterTemplate(temp_mode,"archivePages","bottom")

set fileObj = Server.CreateObject("Scripting.FileSystemObject")

fname = (server.mappath(publish_dir & archive_file))


set txtfile = fileObj.CreateTextFile(fname,true)
	txtfile.write topTemplate & outString & bottomTemplate
	txtfile.close
set txtfile = nothing

set fileObj =nothing
uTemplate = ""
outString = ""
End Sub



' ****************************************
' 
' Process All Archives for a Blog
'
' ****************************************

Sub PublishAllArchives(blogid)

	alist = ArchiveList(blogid,false)

strTemplate = ReadTemplate("archivePages",false,true,false,blogid)
set fs=Server.CreateObject("Scripting.FileSystemObject")

set respLastTitle = GetMultiplePosts("1",true,false,blog_id,"all")
last_title = respLastTitle.fields(7)
set respLastTitle = nothing


If fs.FolderExists(Server.MapPath(writable_dir)) = true Then
	set f=fs.GetFolder(Server.MapPath(writable_dir))
	set fo=f.files

	For each file in fo
		If right(file.name,14) = "archive" & blogid & ".xml" Then
			set resp = GetMonthsPosts(file.name,true,blogid)

			archive_file = left(file.name,(len(file.name)-4)) & archive_ext

			If InStr(1, strTemplate,"<Blogger>") Then
				temp_mode = "blogger"
			End If
		
			If InStr(strTemplate,"/.startmainblog") Then
				temp_mode = "bbt"
			End If

			If InStr(strTemplate,"[+blog") Then
				temp_mode = "bwxml"
			End If

			nextDate = ""

			Do While Not resp.EOF
				bdatetime = resp.fields(1)
				bpostid = resp.fields(2)
				bpostid = ExtractTimestamp(bpostid)
				bauthorname = resp.fields(3)
				bauthormail = resp.fields(4)
				bcommentthread = resp.fields(5)
				btitle = resp.fields(7)
				bbody = resp.fields(8)
				bcatID = resp.fields(10)
				bcatName = resp.fields(11)
				currentDate = left(UnixToHuman(bpostid),8)

				ProcessMidTemplate temp_mode
				resp.MoveNext
				nextDate = currentDate
				outString = outString & uTemplate
			Loop

			topTemplate = ProcessOuterTemplate(temp_mode,"archivePages","top")
			bottomTemplate = ProcessOuterTemplate(temp_mode,"archivePages","bottom")

			set fileObj = Server.CreateObject("Scripting.FileSystemObject")
			fname = (server.mappath(publish_dir & archive_file))
			set txtfile = fileObj.CreateTextFile(fname,true)
				txtfile.write topTemplate & outString & bottomTemplate
				txtfile.close
			set txtfile = nothing

			set fileObj =nothing
		End If

		outString = ""
	Next
	set fo = nothing
	set f = nothing
Else
	Exit Sub
End If

set fs = nothing
uTemplate = ""
End Sub




' ****************************************
' 
' Process Syndication file
'
' ****************************************
Sub PublishSyndicationFile(byVal blogid, byVal syndFilename, byVal templateName)

strTemplate = ReadTemplate(templateName,false,true,false,blogid)

readCategory = PreProcessTemplate(strTemplate)

If readCategory = "" Then
	readCategory = "all"
End If

If InStr(1, strTemplate,"[+blog") Then
	temp_mode = "bwxml"
ElseIf InStr(1, strTemplate,"/.startmainblog") Then
	temp_mode = "bbt"
ElseIf InStr(1, strTemplate,"<Blogger>") Then
	temp_mode = "blogger"
End If

nextDate = ""

On Error Resume Next
set resp = GetMultiplePosts(per_page,true,false,blogid,readCategory)
If Err <> 0 Then
	Exit Sub
End If

Do While Not resp.EOF
	bdatetime = resp.fields(1)
	bpostid = resp.fields(2)
	bpostid = ExtractTimestamp(bpostid)
	bauthorname = resp.fields(3)
	bauthormail = resp.fields(4)
	bcommentthread = resp.fields(5)
	btitle = resp.fields(7)
	bbody = resp.fields(8)
	bcatID = resp.fields(10)
	bcatName = resp.fields(11)

	currentDate = left(UnixToHuman(bpostid),8)

	ProcessMidTemplate temp_mode

	resp.MoveNext
	nextDate = currentDate
	outString = outString & uTemplate
Loop

topTemplate = ProcessOuterTemplate(temp_mode,templateName,"top")
bottomTemplate = ProcessOuterTemplate(temp_mode,templateName,"bottom")


set fileObj = Server.CreateObject("Scripting.FileSystemObject")
fname = (server.mappath(publish_dir & syndFilename))



set txtfile = fileObj.CreateTextFile(fname,true)
	txtfile.write topTemplate & outString & bottomTemplate
	txtfile.close
set txtfile = nothing

set fileObj =nothing
uTemplate = ""
outString = ""
End Sub


' ****************************************
' 
' Process Archive Index
'
' ****************************************

Sub PublishArchiveIndex(blogid,indexpagename)
strTemplate = ReadTemplate("archiveIndex",false,true,false,blogid)

If InStr(1, strTemplate,"<Blogger>") Then
	temp_mode = "blogger"
	set fs=Server.CreateObject("Scripting.FileSystemObject")
	
	If fs.FolderExists(Server.MapPath(writable_dir)) = true Then
		set f=fs.GetFolder(Server.MapPath(writable_dir))
		set fo=f.files
	
		For each file in fo
			If right(file.name,14) = "archive" & blog_id & ".xml" Then
				archive_file = left(file.name,(len(file.name)-4)) & archive_ext
				ProcessMidTemplate temp_mode
				outString = outString & uTemplate
			End If
		Next

		set fo = nothing
		set f = nothing
	End If

set fs = nothing
End If

If InStr(strTemplate,"/.startmainblog") Then
	alist = ArchiveList(blogid,false)
	temp_mode = "bbt"
	ProcessMidTemplate temp_mode
	outString = uTemplate
End If

If InStr(strTemplate,"[+blog") Then
	alist = ArchiveList(blogid,false)
	temp_mode = "bwxml"
	ProcessMidTemplate temp_mode
	outString = uTemplate
End If

topTemplate = ProcessOuterTemplate(temp_mode,"archiveIndex","top")
bottomTemplate = ProcessOuterTemplate(temp_mode,"archiveIndex","bottom")

set fileObj = Server.CreateObject("Scripting.FileSystemObject")
fname = (server.mappath(publish_dir & archive_index_file))
set txtfile = fileObj.CreateTextFile(fname,true)
	txtfile.write topTemplate & outString & bottomTemplate
	txtfile.close
set txtfile = nothing

set fileObj =nothing
End Sub
%>