<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
Function chunkString(sInput)
Dim arWords(15), j, i
i = 0
j = 1

For i = 0 to 15
	arWords(i) = Mid(sInput,j,8)
	j = j + 8
Next

chunkString = arWords
End Function

Private Function padString(sInput,sLength,sPrefix,sDigit)
If len(sInput) <> sLength AND len(sInput) < sLength Then
	If sPrefix = true Then
		Do Until len(sInput) >= sLength
			sInput = sDigit & sInput
		Loop
	Else
		Do Until len(sInput) >= sLength
			sInput =  sInput & sDigit
		Loop
	End If
End If
padString = sInput
End Function

Function shiftString(sInput,sPlaces)
	Dim tmp1,tmp2,tmp3
	tmp1 = sInput
	For count = 1 to sPlaces
		tmp2 = left(tmp1,1)
		tmp3 = right(tmp1,len(tmp1)-1)
		tmp1 = tmp3 & tmp2
	Next
shiftString = tmp1
End Function


Function hashString(sInput) 
Dim a, b, c, i, sTemp
a = 1  

For i = 1 To Len(sInput)    
	a = Sqr(a * Asc(Mid(sInput, i, 1)))
	' adding this line and seeding the rnd generator with 'b' removes the problem of
	' long passwords made up of repeated strings producing the same hash.
	b = b + a
Next  

' make sure the number generated is the same each time given the same seed.
Rnd (-1)
Randomize b

For i = 0 To 31		'produces a 128 digit number
	c = cInt(9000 * Rnd + 1000)
  	sTemp = sTemp  & shiftString(c,i) 
Next 

wordArray = chunkString(sTemp)

Dim hash(7)
hash(0) = wordArray(0) Xor wordArray(15)
hash(1) = wordArray(1) Xor wordArray(14)
hash(2) = wordArray(2) Xor wordArray(13)
hash(3) = wordArray(3) Xor wordArray(12)
hash(4) = wordArray(4) Xor wordArray(11)
hash(5) = wordArray(5) Xor wordArray(10)
hash(6) = wordArray(6) Xor wordArray(9)
hash(7) = wordArray(7) Xor wordArray(8)

For i = 0 to 7
sOutput = sOutput & padString(Hex(hash(i)), 8, true,"0")
Next 

hashString = LCase(sOutput)
End Function


Function miniHash(sInput)
Dim a, b, c, i, sTemp
a = 1  

For i = 1 To Len(sInput)    
	a = Sqr(a * Asc(Mid(sInput, i, 1)))
	' adding this line and seeding the rnd generator with 'b' removes the problem of
	' long passwords made up of repeated strings producing the same hash.
	b = b + a
Next  

' make sure the number generated is the same each time given the same seed.
Rnd (-1)
Randomize b

For i = 0 To 31		'produces a 128 digit number
	c = cInt(9000 * Rnd + 1000)
  	sTemp = sTemp  & shiftString(c,i) 
Next 

wordArray = chunkString(sTemp)

Dim hash(7)
hash(0) = wordArray(0) Xor wordArray(15)
hash(1) = wordArray(1) Xor wordArray(14)
hash(2) = wordArray(2) Xor wordArray(13)
hash(3) = wordArray(3) Xor wordArray(12)
hash(4) = wordArray(4) Xor wordArray(11)
hash(5) = wordArray(5) Xor wordArray(10)
hash(6) = wordArray(6) Xor wordArray(9)
hash(7) = wordArray(7) Xor wordArray(8)

Dim hash2(3)
hash2(0) = hash(0) Xor hash(7)
hash2(1) = hash(1) Xor hash(6)
hash2(2) = hash(2) Xor hash(5)
hash2(3) = hash(3) Xor hash(4)

Dim hash3(1)
hash3(0) = hash2(0) Xor hash2(3)
hash3(1) = hash2(1) Xor hash2(2)

For i = 0 to 1
sOutput = sOutput & padString(Hex(hash3(i)), 8, true,"0")
Next 

miniHash = LCase(sOutput)
End Function
%>