<%
Function extractURLs(strText)

	Dim regEx, Match, Matches 
	Set regEx = New RegExp
	regEx.Pattern = "<a.*?href=""(.*?)"""
	regEx.IgnoreCase = True
	regEx.Global = True
	Set Matches = regEx.Execute(strText)
	count = 0	
	For each Item in Matches
		count = count +1
	Next
	If count = 0 Then
		strOutput = ""
	Else
		For each Match in Matches
		strOutput = strOutput & Match.SubMatches(0) & "!#!"
		Next
		strOutput = left(strOutput,len(strOutput)-3)
	End If
	
	'LogIt strOutput,"extractURLs","pingBack.log"

	If strOutput <> "" Then
		outputArray = split(strOutput,"!#!")
	Else
		outputArray = ""
	End If
extractURLs = outputArray
End Function


Function PingBack(sourceURL, targetURL)
Dim urlAnchor,inUrlNoAnchor,pbServerURL

inUrl = trim(targetURL)

' If there's a # we got most likely a permalink ext so let's split it off, 
' save it and use it later as the target URL
If InStr(inUrl,"#") Then
	hash_pos = InStr(inUrl,"#")
	urlAnchor = right(inUrl,len(inUrl)-hash_pos+1)
	inUrlNoAnchor = left(inUrl,hash_pos-1)
Else
	inUrlNoAnchor = inUrl
End If

' set up the URL properly to be used
If left(inUrlNoAnchor,7) <> "http://" Then
	inUrlNoAnchor = "http://" & inUrlNoAnchor
End If

On Error Resume Next
Err = 0

set pingBackDoc = Server.CreateObject("Microsoft.XMLHTTP")
pingBackDoc.open "GET",inUrlNoAnchor,false
pingBackDoc.setRequestHeader "Pragma","no-cache"
pingBackDoc.setRequestHeader "Cache-Control", "no-cache"
pingBackDoc.send 
response_header = pingBackDoc.getResponseHeader("X-Pingback") 
If response_header <> "" Then
	pbServerURL = response_header
Else
	response_html = (pingBackDoc.responseText)
	Dim regEx, Match, Matches 
	Set regEx = New RegExp
	regEx.Pattern = "<link rel=""pingback"" href=""(.*?)"" ?/?>"
	regEx.IgnoreCase = True
	regEx.Global = True
	Set Matches = regEx.Execute(response_html)
	count = 0	
	For each Item in Matches
	count = count +1
	Next
	If count = 0 Then
		pbServerURL = ""
	Else
		Set Match = Matches(0)
		pbServerURL = Match.SubMatches(0)
	End If
End If

LogIt pbServerURL,"pbServerURL","pingBack.log"

set pingBackDoc = nothing


If pbServerURL <> "" Then
	'Will now build and send the PingBack ping
	xmlString = "<?xml version=""1.0"" encoding=""ISO-8859-1"" ?>" _
		& "<methodCall>" _
		& "<methodName>pingback.ping</methodName>" _
		& "<params>" _
		& "<param>" _
		& "<value>"  & sourceURL & "</value>" _
		& "<name>sourceURI</name>" _
		& "</param>" _
		& "<param>" _
		& "<value>" & targetURL & "</value>" _
		& "<name>targetURI</name>" _
		& "</param>" _
		& "</params>" _
		& "</methodCall>"

LogIt xmlString,"xmlString","pingBack.log"

set xml = Server.CreateObject("Microsoft.XMLHTTP")
xml.open "POST",pbServerURL,true

'Add HTTP headers
xml.setRequestHeader "Content-Type","text/xml"

'Send the previously generated XML string.
xml.send xmlString

set xml = nothing
End If
End Function



Function pingBackCheck(sourceURI,targetURI)
Dim slashPos,reqPage,dotPos,archiveFile,hashPos,postID,result,doSourceCheck

' we're only going to check for standard BlogWorks XML archive page formats.
' if someone is using something none standard (somehow) then it ain't going
' to get checked
' standard archive file format = (year)(month)archive(blogid).(ext)#(postid)
' standard archive XML format = (year)(month)archive(blogid).xml

' TargetURI checking
If InStr(targetURI,"#") = false Then
	pbCheck = 33
Else
	' targetURI should be of form: /(year)(month)archive(blogid).(ext)#(postid)
	slashPos = InStrRev(targetURI,"/")
	reqPage = right(targetURI,len(targetURI)-slashPos)

	dotPos = InStr(reqPage,".")
	archiveFile = left(reqPage,dotPos) & "xml"
	hashPos = InStr(reqPage,"#")
	postID = right(reqPage,len(reqPage)-hashPos)

	result = GetSinglePost(archiveFile,postID)
	If IsArray(result) <> True Then
		pbCheck = 0
	Else
				hashPos = 0
		If InStr(sourceURI,"#") Then
			hashPos = InStr(sourceURI,"#")
			urlAnchor = right(sourceURI,len(sourceURI)-hashPos+1)
			UrlNoAnchor = left(sourceURI,hashPos-1)
		Else
			UrlNoAnchor = sourceURI
		End If

		On Error Resume Next
		Err = 0

		set pingBackDoc = Server.CreateObject("Microsoft.XMLHTTP")
		pingBackDoc.open "GET",UrlNoAnchor,false
		pingBackDoc.setRequestHeader "Pragma","no-cache"
		pingBackDoc.setRequestHeader "Cache-Control", "no-cache"
		pingBackDoc.send 

		If Err <> 0 Then		'Source URI doesn't exist
			set pingBackDoc = nothing
			pbCheck = 16
		Else
			responseHTML = (pingBackDoc.responseText)
			If InStr(responseHTML,targetURI) = false Then
				set pingBackDoc = nothing
				pbCheck = 17
			Else
				' seeing as how we've already got this far
				' may as well attempt to get an extract.
				' use reg-exp to look between <p> and/or <div> tags containing 
				' the targetURI

				' block level elements to check:
				' BLOCKQUOTE
				' DIV (document division)
				' P (paragraph)
				' PRE (preformatted text)
				' TD (table data cell)

				Dim regEx, Match, Matches 
				Set regEx = New RegExp
				regEx.Pattern = targetURI & ".*?</[p|div|td|blockquote|pre]>"
				regEx.IgnoreCase = True
				regEx.Global = True
				Set Matches = regEx.Execute(responseHTML)
				part1 = Matches.Item(0).Value
	
				sTargetURI = strReverse(targetURI)
		
				Set regEx = New RegExp
				regEx.Pattern = sTargetURI & ".*?(>[p|div|td|blockquote|pre]<)"
				regEx.IgnoreCase = True
				regEx.Global = True
				Set Matches = regEx.Execute(strReverse(responseHTML))
				part2 = replace(strReverse(Matches.Item(0).Value),targetURI,"")

				set pingBackDoc = nothing
				If (part2 & part1) <> "" Then
					pbCheck = part2 & part1
				Else
					pbCheck = "OK"
				End If
			End If
		End If
	End If
End If

pingBackCheck = pbCheck

End Function
%>