<%  
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%   
'    RSS & TrackBack Classes for BlogWorks XML
'   Original ASP Classes design courtesy of Paul Schaeflein
%>
<%
Class clsTrackBack
	Dim m_PostID,m_Admin_URL,m_Writable_URL,m_TB
	
	Public Property Let PostID(id)
		m_PostID = id
	End Property

	Public Property Let AdminURL(url)
		m_Admin_URL = cleanURL(url)
	End Property

	Public Property Let WritableURL(url)
		m_Writable_URL = cleanURL(url)
	End Property

	Public Property Get Postid()
		postid = m_PostID
	End Property

	Public Property Get URL()
		URL = m_Admin_URL & "incoming.asp?id=" & m_PostID
	End Property

	Public Property Get DisplayURL()
		DisplayURL = m_Admin_URL & "rx_display.asp?id=" & m_PostID
	End Property

	Private Property Get MappedAdminDir()
		dir = urlTodir(m_Admin_URL)
		MappedAdminDir = Server.Mappath(dir) & "\"
	End Property

	Private Property Get MappedIncomingDir()
		dir = urlTodir(m_Writable_URL)
		dir = dir & subIncoming
		MappedIncomingDir = Server.Mappath(dir) & "\"
	End Property

	Private Function cleanURL(url)
		If right(url,1) <> "/" Then
			url = url & "/"
		End If
		
		cleanURL = url
	End Function

	Private Function urlTodir(url)
		server_name = request.servervariables("SERVER_NAME")
		server_name = "http://" & server_name

		url = cleanURL(url)

		dir = right(url,len(url)-len(server_name))
		urlTodir = dir
	End Function

	Public Sub Initialize()
		' Load the received TrackBacks into memory
		Set m_TB = Server.CreateObject(bw_xmlCheck)
		m_TB.setProperty "SelectionLanguage","XPath" 
		m_TB.load MappedIncomingDir & "rx" & PostID & ".xml"
	End Sub

	Public Sub Terminate()
		Set m_TB = nothing
	End Sub

	Public Property Get Pings()
		Dim oPings
		
		' Get the Pings collection
		Dim sXPath
		sXPath = "//item"
		Set m_Pings = m_TB.selectNodes(sXPath)

		Set oPings = New ClsTBpings
		oPings.Initialize(m_Pings)
		Set Pings = oPings
	End Property

	Public Property Get Count()
		Dim oPings
		
		' Get the Pings collection
		Dim sXPath
		sXPath = "//item"
		Set m_Pings = m_TB.selectNodes(sXPath)
		Count = m_Pings.length
	End Property

End Class

Class ClsTBpings
	Private m_Pings
	
	Public Sub Initialize(oNodeList)
		Set m_Pings = oNodeList
	End Sub
	
	Public Property Get Length
		Length = m_Pings.Length 
	End Property

	Public Property Get Item(index)
		Dim oPing
		Set oPing = New clsTBping

		' First, pass the correct node to the class
		oPing.Initialize m_Pings.item(index)
				
		' Then, send the class to the caller
		Set Item = oPing
	End Property
End Class


Class clsTBping
	Dim m_Ping

	Public Sub Initialize(oNode)
		Set m_Ping = oNode
	End Sub

	Private Function NodeCheck(named_node,node_list)
		set m_Ping_list = node_list.selectNodes("*")
		stopFlag = false
		For Each Node In m_Ping_list
			If Node.nodeName = named_node Then
				stopFlag = true
				Exit For
			End If
		Next
		set m_Ping_list = nothing
		If stopFlag = true Then
			intern = m_Ping.selectSingleNode(named_node).text
		Else
			intern = ""
		End If
		stopFlag = false
		NodeCheck = intern
	End Function


	Public Property Get time()
		time = NodeCheck("pubDate",m_Ping)
	End Property
	
	Public Property Get link()
		link = NodeCheck("link",m_Ping)
	End Property

	Public Property Get title()
		title = NodeCheck("title",m_Ping)
	End Property

	Public Property Get source()
		source = NodeCheck("source",m_Ping)
	End Property

	Public Property Get author()
		author = NodeCheck("author",m_Ping)
	End Property

	Public Property Get description()
		description = NodeCheck("description",m_Ping)
	End Property

	Public Property Get category()
		category = NodeCheck("category",m_Ping)
	End Property

	Public Property Get guid()
		guid = NodeCheck("guid",m_Ping)
	End Property

End Class
%>