<%  
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
Function stripHTML(textInput, removeLink)
' this is a very basic HTML removal function. It's easy to break if you use
' < and > in ways other than as HTML. You can use either as long as they don't both
' appear in the same piece of text.
' removeLink is optional by default is false


	Set regEx = New RegExp
	regEx.Pattern = "<((/|[a-zA-Z]).*?)>"

	regEx.IgnoreCase = True
	regEx.Global = True
	Set Matches = regEx.Execute(textInput)

	If removeLink = false Then
		For Each Match in Matches   ' Iterate Matches collection.
			If inStr(Match.Value,"<a ") = false Then
				If inStr(Match.Value,"</a>") = false Then
					indexHTML = indexHTML & "|" & Match.Value
				End If
			End If
		Next
	Else
		For Each Match in Matches   ' Iterate Matches collection.
			indexHTML = indexHTML & "|" & Match.Value
		Next
	End If
	
	Set regEx = nothing

	If indexHTML <> "" Then
		IndexHTML = right(indexHTML,len(indexHTML)-1)

		indexArray = split(indexHTML,"|")
	
		For count = lbound(indexArray) to ubound(indexArray)
			textInput = replace(textInput,indexArray(count),"")
		Next

		stripHTML = textInput
		Exit Function
	Else
		stripHTML = textInput
	End If
End Function

Function entityEncodeNonHTML(strInput)
	tempHTML = strInput
	' Encode all entities and then change 'em back using reg-exp
	' but! we don't want to hit tags that might be there legitametely i.e. using &lt;tag&gt; to show HTML
	tempHTML = replace(tempHTML,"&lt;","#lt;")
	tempHTML = replace(tempHTML,"&gt;","#gt;")
	tempHTML = entityEncode(tempHTML)

	Set regEx = New RegExp
	regEx.Pattern = "&lt;((/|[a-zA-Z]).*?)&gt;"

	regEx.IgnoreCase = True
	regEx.Global = True

	Set Matches = regEx.Execute(tempHTML)

	For Each Match in Matches   ' Iterate Matches collection.
		temp = temp & Match.Value & "!! " & Match.FirstIndex  & "##"

		' convert tag back to HTML
		' replace Match with converted match at FirstIndex point starting from end...
	Next
	Set regEx = nothing
	
	If temp <> "" Then
		temp = left(temp,len(temp)-2)
		tempArray = split(temp,"##")

		For i = ubound(tempArray) to lbound(tempArray) step -1
			matchArray = split(tempArray(i),"!!")
			matchValueUE = matchArray(0)
			matchValue = entityUnEncode(matchArray(0),false)
			matchPos = matchArray(1)

			tempHTML = replace(tempHTML,matchValueUE,matchValue)
		Next
	eENH = replace(tempHTML,"#lt;","&lt;")
	eENH = replace(eENH,"#gt;","&gt;")
		'eENH = tempHTML
	Else
		eENH = entityEncode(strInput)
	End If
	
	entityEncodeNonHTML = eENH
End Function


Function entityEncode(strInput)
	strOutput = replace(strInput,"&","&amp;")
	strOutput = replace(strOutput,"""","&quot;")
	strOutput = replace(strOutput,"<","&lt;")
	strOutput = replace(strOutput,">","&gt;")
	entityEncode = strOutput
End Function

Function entityNameToNumber(strInput)
        strOutput = replace(strInput,"&nbsp;","&#160;")
        strOutput = replace(strOutput,"&iexcl;","&#161;")
        strOutput = replace(strOutput,"&cent;","&#162;")
        strOutput = replace(strOutput,"&pound;","&#163;")
        strOutput = replace(strOutput,"&curren;","&#164;")
        strOutput = replace(strOutput,"&yen;","&#165;")
        strOutput = replace(strOutput,"&brvbar;","&#166;")
        strOutput = replace(strOutput,"&sect;","&#167;")
        strOutput = replace(strOutput,"&uml;","&#168;")
        strOutput = replace(strOutput,"&copy;","&#169;")
        strOutput = replace(strOutput,"&ordf;","&#170;")
        strOutput = replace(strOutput,"&laquo;","&#171;")
        strOutput = replace(strOutput,"&not;","&#172;")
        strOutput = replace(strOutput,"&shy;","&#173;")
        strOutput = replace(strOutput,"&reg;","&#174;")
        strOutput = replace(strOutput,"&macr;","&#175;")
        strOutput = replace(strOutput,"&deg;","&#176;")
        strOutput = replace(strOutput,"&plusmn;","&#177;")
        strOutput = replace(strOutput,"&sup2;","&#178;")
        strOutput = replace(strOutput,"&sup3;","&#179;")
        strOutput = replace(strOutput,"&acute;","&#180;")
        strOutput = replace(strOutput,"&micro;","&#181;")
        strOutput = replace(strOutput,"&para;","&#182;")
        strOutput = replace(strOutput,"&middot;","&#183;")
        strOutput = replace(strOutput,"&cedil;","&#184;")
        strOutput = replace(strOutput,"&sup1;","&#185;")
        strOutput = replace(strOutput,"&ordm;","&#186;")
        strOutput = replace(strOutput,"&raquo;","&#187;")
        strOutput = replace(strOutput,"&frac14;","&#188;")
        strOutput = replace(strOutput,"&frac12;","&#189;")
        strOutput = replace(strOutput,"&frac34;","&#190;")
        strOutput = replace(strOutput,"&iquest;","&#191;")
        strOutput = replace(strOutput,"&Agrave;","&#192;")
        strOutput = replace(strOutput,"&Aacute;","&#193;")
        strOutput = replace(strOutput,"&Acirc;","&#194;")
        strOutput = replace(strOutput,"&Atilde;","&#195;")
        strOutput = replace(strOutput,"&Auml;","&#196;")
        strOutput = replace(strOutput,"&Aring;","&#197;")
        strOutput = replace(strOutput,"&AElig;","&#198;")
        strOutput = replace(strOutput,"&Ccedil;","&#199;")
        strOutput = replace(strOutput,"&Egrave;","&#200;")
        strOutput = replace(strOutput,"&Eacute;","&#201;")
        strOutput = replace(strOutput,"&Ecirc;","&#202;")
        strOutput = replace(strOutput,"&Euml;","&#203;")
        strOutput = replace(strOutput,"&Igrave;","&#204;")
        strOutput = replace(strOutput,"&Iacute;","&#205;")
        strOutput = replace(strOutput,"&Icirc;","&#206;")
        strOutput = replace(strOutput,"&Iuml;","&#207;")
        strOutput = replace(strOutput,"&ETH;","&#208;")
        strOutput = replace(strOutput,"&Ntilde;","&#209;")
        strOutput = replace(strOutput,"&Ograve;","&#210;")
        strOutput = replace(strOutput,"&Oacute;","&#211;")
        strOutput = replace(strOutput,"&Ocirc;","&#212;")
        strOutput = replace(strOutput,"&Otilde;","&#213;")
        strOutput = replace(strOutput,"&Ouml;","&#214;")
        strOutput = replace(strOutput,"&times;","&#215;")
        strOutput = replace(strOutput,"&Oslash;","&#216;")
        strOutput = replace(strOutput,"&Ugrave;","&#217;")
        strOutput = replace(strOutput,"&Uacute;","&#218;")
        strOutput = replace(strOutput,"&Ucirc;","&#219;")
        strOutput = replace(strOutput,"&Uuml;","&#220;")
        strOutput = replace(strOutput,"&Yacute;","&#221;")
        strOutput = replace(strOutput,"&THORN;","&#222;")
        strOutput = replace(strOutput,"&szlig;","&#223;")
        strOutput = replace(strOutput,"&agrave;","&#224;")
        strOutput = replace(strOutput,"&aacute;","&#225;")
        strOutput = replace(strOutput,"&acirc;","&#226;")
        strOutput = replace(strOutput,"&atilde;","&#227;")
        strOutput = replace(strOutput,"&auml;","&#228;")
        strOutput = replace(strOutput,"&aring;","&#229;")
        strOutput = replace(strOutput,"&aelig;","&#230;")
        strOutput = replace(strOutput,"&ccedil;","&#231;")
        strOutput = replace(strOutput,"&egrave;","&#232;")
        strOutput = replace(strOutput,"&eacute;","&#233;")
        strOutput = replace(strOutput,"&ecirc;","&#234;")
        strOutput = replace(strOutput,"&euml;","&#235;")
        strOutput = replace(strOutput,"&igrave;","&#236;")
        strOutput = replace(strOutput,"&iacute;","&#237;")
        strOutput = replace(strOutput,"&icirc;","&#238;")
        strOutput = replace(strOutput,"&iuml;","&#239;")
        strOutput = replace(strOutput,"&eth;","&#240;")
        strOutput = replace(strOutput,"&ograve;","&#242;")
        strOutput = replace(strOutput,"&oacute;","&#243;")
        strOutput = replace(strOutput,"&ocirc;","&#244;")
        strOutput = replace(strOutput,"&otilde;","&#245;")
        strOutput = replace(strOutput,"&ouml;","&#246;")
        strOutput = replace(strOutput,"&divide;","&#247;")
        strOutput = replace(strOutput,"&ugrave;","&#249;")
        strOutput = replace(strOutput,"&uacute;","&#250;")
        strOutput = replace(strOutput,"&ucirc;","&#251;")
        strOutput = replace(strOutput,"&uuml;","&#252;")
        strOutput = replace(strOutput,"&yacute;","&#253;")
        strOutput = replace(strOutput,"&thorn;","&#254;")
        strOutput = replace(strOutput,"&yuml;","&#255;")
entityNameToNumber = strOutput
End Function

Function asciiToEntity(strInput)
	textCount = len(strInput)

	' turn letters with ASCII number greater than 159 into their entity equivalent for HTML/XML output
	For i = textCount to 1 step -1
		If Asc(mid(strInput,i,1)) > 159 Then
			strInput = replace(strInput,mid(strInput,i,1),"&#" & Asc(mid(strInput,i,1)) & ";")
		End If
	Next
	asciiToEntity = strInput
End Function


Function entityUnEncode(strInput,incAmp)
	If incAmp = true Then
		strOutput = replace(strInput,"&amp;","&")
		strOutput = replace(strOutput,"&quot;","""")
		strOutput = replace(strOutput,"&lt;","<")
		strOutput = replace(strOutput,"&gt;",">")
	Else
		strOutput = replace(strInput,"&quot;","""")
		strOutput = replace(strOutput,"&lt;","<")
		strOutput = replace(strOutput,"&gt;",">")
	End If
	entityUnEncode = strOutput
End Function



Function filterText(textInput,blockType,blockClass,blockID)
	If blockID <> "" Then
		blockID = " id=""" & blockID & """"
	End If
	If blockClass <> "" Then
		blockClass = " class=""" & blockClass & """"
	End If
	If blockType = "" Then
		blockType = "p"
	End If

	strText = replace(textInput,chr(10) & chr(10),"</" & blockType & "><" & blockType & blockClass & blockID & ">")
	strText = replace(strText,chr(10),linebreaktag)
	strText = "<" & blockType & blockClass & blockID & ">" & strText & "</" & blockType & ">"
	strText = asciiToEntity(strText)
	strText = entityNameToNumber(strText)
	filterText = strText
End Function
%>