<%  
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
Function HumanToUnix(datetime)
If datetime <> "" Then
	fyear = left(datetime,4)
	fmonth = right(left(datetime,6),2)
	fday = right(left(datetime,8),2)
	fhour = right(left(datetime,11),2)
	fminute = right(left(datetime,14),2)
	fsecond = right(datetime,2)
Else
	fday = Day(now)
	fmonth = Month(now)
	fyear = Year(now)
	fhour = Hour(now)
	fminute = Minute(now)
	fsecond = Second(now)
End If

time_stamp = (fhour*3600) + (fminute*60) + (fsecond)
date_target = DateSerial(fyear,fmonth,fday)
date_ref = DateSerial(1970,01,01)
date_stamp = DateDiff("s",date_ref,date_target)

unix_stamp = date_stamp + time_stamp
HumanToUnix = unix_stamp
End Function

Function UnixToHuman(timestamp)
If timestamp = "" Then
UnixToHuman = "Error"
Exit Function
Else
target_date = DateAdd("s",timestamp,DateSerial(1970,01,01))
fyear = Year(target_date)
fmonth = Month(target_date)
fday = Day(target_date)
fhour = Hour(target_date)
fminute = Minute(target_date)
fsecond = Second(target_date)
If len(fmonth) = "1" Then
fmonth = "0" & fmonth
End If
If len(fday) = "1" Then
fday = "0" & fday
End If
If len(fhour) = "1" Then
fhour = "0" & fhour
End If
If len(fminute) = "1" Then
fminute = "0" & fminute
End If
If len (fsecond) = "1" Then
fsecond = "0" & fsecond
End If
UnixToHuman = fyear & fmonth & fday & "T" & fhour & ":" & fminute & ":" & fsecond
End If
End Function



Function UnixToRSS(timestamp,mode)

' mode: iso8601 or rfc822


If timestamp = "" Then
UnixToRSS = "Error"
Exit Function
Else
' we need to remove then remove time zone offset;

t_zone = 3600 * time_zone
timestamp = timestamp - t_adjust - t_zone
target_date = DateAdd("s",timestamp,DateSerial(1970,01,01))
fyear = Year(target_date)
fmonth = Month(target_date)
Select Case fmonth
Case "1"
fmonth_name = "Jan"
Case "2"
fmonth_name = "Feb"
Case "3"
fmonth_name = "Mar"
Case "4"
fmonth_name = "Apr"
Case "5"
fmonth_name = "May"
Case "6"
fmonth_name = "Jun"
Case "7"
fmonth_name = "Jul"
Case "8"
fmonth_name = "Aug"
Case "9"
fmonth_name = "Sep"
Case "10"
fmonth_name = "Oct"
Case "11"
fmonth_name = "Nov"
Case "12"
fmonth_name = "Dec"
End Select
If len(fmonth) = 1 Then
fmonth = "0" & fmonth
End If


fday = Day(target_date)
If len(fday) = 1 Then
fday = "0" & fday
End If
fday_num = WeekDay(target_date)
Select Case fday_num
Case "1"
fday_name = "Sun"
Case "2"
fday_name = "Mon"
Case "3"
fday_name = "Tue"
Case "4"
fday_name = "Wed"
Case "5"
fday_name = "Thu"
Case "6"
fday_name = "Fri"
Case "7"
fday_name = "Sat"
End Select

fhour = Hour(target_date)
fminute = Minute(target_date)
fsecond = Second(target_date)
If len(fhour) = "1" Then
fhour = "0" & fhour
End If
If len(fminute) = "1" Then
fminute = "0" & fminute
End If
If len (fsecond) = "1" Then
fsecond = "0" & fsecond
End If

If mode = "rfc822" Then
	UnixToRSS = fday_name & ", " & fday & " " & fmonth_name & " " & fyear & " " & fhour & ":" & fminute & ":" & fsecond & " GMT"
ElseIf mode = "iso8601" Then
	UnixToRSS = fyear & "-" & fmonth & "-" & fday & "T" & fhour & ":" & fminute & ":" & fsecond & "Z"
ElseIf mode = "xmlrpc" Then
	UnixToRSS = fyear & fmonth & fday & "T" & fhour & ":" & fminute & ":" & fsecond
End If
	
End If
End Function



' ********************************
' New Timestamp and Date/Time related functions
' ********************************

Function CreateTimestamp()
	fday = Day(now)
	fmonth = Month(now)
	fyear = Year(now)
	fhour = Hour(now)
	fminute = Minute(now)
	fsecond = Second(now)

	time_stamp = (fhour*3600) + (fminute*60) + (fsecond)
	date_target = DateSerial(fyear,fmonth,fday)
	date_ref = DateSerial(1970,01,01)
	date_stamp = DateDiff("s",date_ref,date_target)

	unix_stamp = date_stamp + time_stamp
	CreateTimestamp = unix_stamp
End Function
%>