<%  
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
Sub UpdateConfigVersion(strNewVersion,strXML)
	Dim regEx
	Set regEx = New RegExp
	regEx.Pattern = "<blogconfig version="".*?"""
	regEx.IgnoreCase = True
	regEx.Global = True
	strXML = regEx.Replace(strXML, "<blogconfig version=""" & strNewVersion & """")
	Set regEx = nothing
End Sub

Sub UpdateElementContents(strElementName,strNewContent,strXML)
	Dim regEx
	Set regEx = New RegExp
	regEx.Pattern = "<" & strElementName & ">.*?<"
	regEx.IgnoreCase = True
	regEx.Global = True
	strXML = regEx.Replace(strXML, "<" & strElementName & ">" & strNewContent & "<")
	Set regEx = nothing
End Sub

Sub RemoveElement(strElementName,strXML)
	Dim regEx
	Set regEx = New RegExp
	regEx.Pattern = "<" & strElementName & ">.*?</" & strElementName & ">"
	regEx.IgnoreCase = True
	regEx.Global = True
	strXML = regEx.Replace(strXML,"")
	Set regEx = nothing

	Set regEx = New RegExp
	regEx.Pattern = "<" & strElementName & "/>"
	regEx.IgnoreCase = True
	regEx.Global = True
	strXML = regEx.Replace(strXML,"")
	Set regEx = nothing
End Sub

Function AddNewElement(strElementName,strDefault,strXML)
	strXML = replace(strXML,"</standard>","<" & strElementName & ">" & strDefault & "</" & strElementName & "></standard>")
	AddNewElement = strXML
End Function

Function ReadConfigText()
	set fls=Server.CreateObject("Scripting.FileSystemObject")
	If fls.FileExists(server.mappath(writable_dir & subData & subSlash & "config.xml")) = true Then
		flname = (server.mappath(writable_dir & subData & subSlash & "config.xml"))
		set txtfile = fls.OpenTextFile(flname, 1, 0)
		data = txtfile.ReadAll
		txtfile.close
		set txtfile = nothing
		set fls = nothing
	End If
	ReadConfigText = data
End Function

Function SaveConfigText(strConfig)
	set fls=Server.CreateObject("Scripting.FileSystemObject")
	If fls.FileExists(server.mappath(writable_dir & subData & subSlash & "config.xml")) = true Then
		flname = (server.mappath(writable_dir & subData & subSlash & "config.xml"))
		set txtfile = fls.OpenTextFile(flname, 2, 1)
		txtfile.write strConfig
		txtfile.close
		set txtfile = nothing
		set fls = nothing
	End If
End Function


Function UpgradeConfigFrom12To13(targetFile)
	configData = ReadConfigText
	UpdateConfigVersion "1.3", configData
	RemoveElement "rssfile", configData
	RemoveElement "ping1", configData
	RemoveElement "ping2", configData
	RemoveElement "ping3", configData
	RemoveElement "pingBGS", configData
	RemoveElement "pingBlogWorks", configData
	RemoveElement "plugins", configData
	SaveConfigText(configData)

	configCount = CountConfigs("config.xml")
	For i = 1 to configCount
		blogStr = blogStr & "<blog id=""" & addZeros(i) & """></blog>"
	Next
	SaveXMLText "categories.xml","<?xml version=""1.0"" encoding=""ISO-8859-1"" ?><categories>" & blogStr & "</categories>"
	SaveXMLText "syndication.xml","<?xml version=""1.0"" encoding=""ISO-8859-1"" ?><syndication>" & blogStr & "</syndication>"
' ::: TO DO ::: - add in default pinging locations.
	SaveXMLText "pings.xml","<?xml version=""1.0"" encoding=""ISO-8859-1"" ?><pings>" & replace(blogStr,"</blog>","<ping alias=""tvcymycc""><fromName></fromName><fromURL></fromURL><toName>weblogs.com</toName><toURL>http://rpc.weblogs.com/RPC2</toURL><toHost>rpc.weblogs.com</toHost></ping><ping alias=""qzedcamg""><fromName></fromName><fromURL></fromURL><toName>blo.gs</toName><toURL>http://ping.blo.gs</toURL><toHost>ping.blo.gs</toHost></ping><ping alias=""hkemvfkc""><fromName></fromName><fromURL></fromURL><toName>BlogWorks</toName><toURL>http://www26.brinkster.com/blogw/update.asp</toURL><toHost></toHost></ping></blog>") & "</pings>"

End Function


Function UpgradeConfigFrom11To12(targetFile)
	'backup the config.xml file
	BackupXML "config.xml",writable_dir & subData & subSlash
	configData = ReadConfigText
	UpdateConfigVersion "1.2", configData
	UpdateElementContents "dateformat", "Weekday, dd[ord] Month, yyyy", configData
	UpdateElementContents "timeformat", "HH:MM", configData
	UpdateElementContents "archivedateformat", "Month, yyyy", configData
	RemoveElement "rssversion", configData
	SaveConfigText(configData)

	' this will be the last programmatic change to the user001.asp file on upgrading.
	' it introduced hashed passwords.
	set fls=Server.CreateObject("Scripting.FileSystemObject")
	flname = (server.mappath(writable_dir & subData & subSlash & subProfiles & subSlash & "user001.asp"))
	set txtfile = fls.OpenTextFile(flname, 1, 0)
	txtfile.SkipLine
	passwd = StripA(txtfile.Readline)
	first_name = StripA(txtfile.Readline)
	last_name = StripA(txtfile.Readline)
	nick_name = StripA(txtfile.Readline)
	user_name = StripA(txtfile.Readline)
	e_mail = StripA(txtfile.Readline)
	txtfile.close
	set txtfile = nothing
	set fls = nothing

	set fileObj = Server.CreateObject("Scripting.FileSystemObject")
	fname = (server.mappath(writable_dir & subData & subSlash & subProfiles & subSlash & "user001.asp"))
	If fileObj.FileExists(fname) Then
		set txtfile = fileObj.CreateTextFile(fname,true)
		txtfile.writeline (chr(60) & "% 'the a= does nothing but hide the values if someone calls up this file directly")
		txtfile.writeline "a=""" & hashString(passwd) & """"
		txtfile.writeline "a=""" & first_name & """"
		txtfile.writeline "a=""" & last_name & """"
		txtfile.writeline "a=""" & nick_name & """"
		txtfile.writeline "a=""" & user_name & """"
		txtfile.writeline "a=""" & e_mail & """"
		txtfile.writeline ("%" & chr(62))
		txtfile.close
		set txtfile = nothing
	End If
	set fileObj = nothing
End Function

' This is all old code but there is little point updating 
' it to reflect the new subs and functions for config file handling.

Function UpgradeConfigFrom10To11(targetFile)
'backup the config.xml file
BackupXML "config.xml",writable_dir & subData & subSlash

' Read in config.xml file
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.setProperty "SelectionLanguage","XPath"
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
UpgradeConfig = GeneralError
Exit Function

End If
Set xmlRoot = objXMLDoc.documentElement

' update version number to 1.1
config_ver = xmlRoot.getAttribute("version")
Set Attr = objXMLDoc.createAttribute("version") 
Set Text = objXMLDoc.createTextNode("1.1") 
Attr.appendChild(Text) 
Set Elem = xmlRoot
Elem.setAttributeNode(Attr) 

' for each blog config add the XML fragment
' should be able to do this using XPath
sXPath = "//blog/standard"
Set nodelist = xmlRoot.selectNodes(sxPath)


For each node in nodelist
Set xmlFragment = objXMLDoc.createDocumentFragment()
Set objNewTimeZone = objXMLDoc.createElement("timezone")
objNewTimeZone.text = "0"
xmlFragment.appendChild(objNewTimeZone)
Set objNewArchiveOrder = objXMLDoc.createElement("archiveorder")
objNewArchiveOrder.text = "0"
xmlFragment.appendChild(objNewArchiveOrder)
Set objNewPingBGS = objXMLDoc.createElement("pingBGS")
xmlFragment.appendChild(objNewPingBGS)
Set objNewPingBW = objXMLDoc.createElement("pingBlogWorks")
xmlFragment.appendChild(objNewPingBW)
Set objNewRSSVersion = objXMLDoc.createElement("rssversion")
objNewRSSVersion.text = "2.0"
xmlFragment.appendChild(objNewRSSVersion)
node.appendChild(xmlFragment)
set xmlFragment = nothing
Next

' add the <plugins> element
Set xmlFragment2 = objXMLDoc.createDocumentFragment()
Set objNewPlugins = objXMLDoc.createElement("plugins")
xmlFragment2.appendChild(objNewPlugins)
xmlRoot.appendChild(xmlFragment2)

' save the whole thing
Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & subData & subSlash)) = True Then
objXMLDoc.save(server.mappath(writable_dir & subData & subSlash & targetFile))
Else
GeneralError = "1.4"   'Can't save edited data
UpgradeConfig = GeneralError
Exit Function
End If
set fs = nothing
Set objXMLDoc = nothing

End Function

%>