<%   
'    Adrian Frost - BlogWorks XML 1.3.0
'    Copyright  2002-2003  Adrian Frost
'    Released under the GNU General Public License (see LICENCE.TXT)
%>
<%
' ****************************************
' 
' Backup XML files before any operations!
' this sub keeps a rolling list of last five changes.
'
' ****************************************

Public Sub BackupXML(fileName,originalPath)
backupFile = left(fileName,len(fileName)-4)
Set fso = CreateObject("Scripting.FileSystemObject")
If fso.fileExists(server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk4")) Then
	' copy to bk 5
	fso.CopyFile (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk4")), (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk5")), true
End If

If fso.fileExists(server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk3")) Then
	' copy to bk 4
	fso.CopyFile (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk3")), (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk4")), true
End If

If fso.fileExists(server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk2")) Then
	' copy to bk 3
	fso.CopyFile (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk2")), (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk3")), true
End If

If fso.fileExists(server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk1")) Then
	' copy to bk 2
	fso.CopyFile (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk1")), (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk2")), true
End If

'copy curent XML to bk1
fso.CopyFile (server.mappath(originalPath & backupFile & ".xml")), (server.mappath(writable_dir & subBackup & subSlash & backupFile & ".bk1")), true
End Sub



' ****************************************
' 
' Create Blog File sub
'
' ****************************************

Public Sub CreateBlog(targetFile)
Set objXMLDoc = Server.CreateObject(bw_xmlCheck) 
Set procBlog = objXMLDoc.createProcessingInstruction("xml","version=""1.0"" encoding=""" & encode_as & """")
objXMLDoc.appendChild(procBlog)

Set rootBlog = objXMLDoc.createElement("baef")
objXMLDoc.appendChild(rootBlog)

Set objAttr = objXMLDoc.createAttribute("version") 
Set xmlRoot = objXMLDoc.documentElement

xmlRoot.setAttribute "version", "1.0" 

Set fs = Server.CreateObject("Scripting.FileSystemObject")

If fs.FolderExists(server.mappath(writable_dir)) = True Then
	objXMLDoc.save(server.mappath(writable_dir & targetFile))
Else
	GeneralError = "cb_xml1"
	Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Blog Append Post sub
'
' ****************************************

Public Sub AppendBlog(targetFile)

BackupXML targetFile,writable_dir

Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 

If ParseErr.errorCode <> 0 Then 
	GeneralError = "ab_xml2"  'Couldn't parse document
	Exit Sub
End If

Set xmlRoot = objXMLDoc.documentElement
Set objNewBlog = objXMLDoc.createElement("blog")
objNewBlog.setAttribute "id", postID 
xmlRoot.InsertBefore objNewBlog,xmlRoot.firstChild

'Author Element
Set objNewAuthor = objXMLDoc.createElement("author")
objNewBlog.appendChild(objNewAuthor)

Set objAuthorName = objXMLDoc.createElement("authorname")
objAuthorName.text = postAuthorName
objNewAuthor.appendChild(objAuthorName)

Set objAuthorMail = objXMLDoc.createElement("authormail")
objAuthorMail.text = postAuthorMail
objNewAuthor.appendChild(objAuthorMail)

'Information Element
Set objNewInfo = objXMLDoc.CreateElement("information")
objNewBlog.appendChild(objNewInfo)

Set objInfoComment = objXMLDoc.createElement("commentthread")
objInfoComment.text = postCommentID
objNewInfo.appendChild(objInfoComment)

Set objInfoStamp = objXMLDoc.createElement("timestamp")
objInfoStamp.text = postTime
objNewInfo.appendChild(objInfoStamp)

Set objInfoLang = objXMLDoc.createElement("language")
objInfoLang.text = blog_lang
objNewInfo.appendChild(objInfoLang)

Set objInfoCats = objXMLDoc.createElement("categories")
objNewInfo.appendChild(objInfoCats)

Set objInfoCat = objXMLDoc.createElement("category")
objInfoCat.setAttribute "id", postCatID 
objInfoCat.text = postCatName
objInfoCats.appendChild(objInfoCat)

'Text Element
Set objNewText = objXMLDoc.CreateElement("text")
objNewBlog.appendChild(objNewText)

Set objTextTitle = objXMLDoc.createElement("blogtitle")
Set objTextTitleCD = objXMLDoc.createCDATASection(postTitle)
objTextTitle.appendChild(objTextTitleCD)
objNewText.appendChild(objTextTitle)

Set objTextBody = objXMLDoc.createElement("blogbody")
Set objTextBodyCD = objXMLDoc.createCDATASection(postBody)
objTextBody.appendChild(objTextBodyCD)
objNewText.appendchild(objTextBody)

Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir)) = True Then
	objXMLDoc.save(server.mappath(writable_dir & targetFile))
Else
	GeneralError = "ab_xml3"   'Can't save appended data
	Set objXMLDoc = nothing
	Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Blog Delete Post Sub
'
' ****************************************

Public Sub DelPost(targetfile,postid)
BackupXML targetFile,writable_dir
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
	GeneralError = "dp_xml2" 'Couldn't parse document
	Exit Sub
End If
Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
For i = 0 to n_blogs-1
If blogs.item(i).getAttribute("id") = postid Then
	nodeToRemove = i
End If
Next
Set objExNode = xmlRoot.removeChild(xmlRoot.childNodes.item(nodeToRemove)) 
Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir)) = True Then
	If n_blogs = 1 Then
		fs.DeleteFile server.mappath(writable_dir & targetFile), true
	Else
		objXMLDoc.save(server.mappath(writable_dir & targetFile))
	End If
Else
	GeneralError = "xml4"   'Can't save edited data
	Set objXMLDoc = nothing
	Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Blog Delete Comment Sub
'
' ****************************************

Public Sub DelComment(targetFile,nodeToRemove)
BackupXML targetFile,writable_dir & subIncoming & subSlash
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & subIncoming & subSlash & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
	GeneralError = "dc_xml2" 'Couldn't parse document
	Exit Sub
End If
Set xmlRoot = objXMLDoc.documentElement
Set items = xmlRoot.getElementsByTagName("item")
n_items = items.length

Set objExNode = xmlRoot.removeChild(xmlRoot.childNodes.item(nodeToRemove)) 
Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & subIncoming)) = True Then
	If n_items = 1 Then
		fs.DeleteFile server.mappath(writable_dir & subIncoming & subSlash & targetFile), true
	Else
		objXMLDoc.save(server.mappath(writable_dir & subIncoming & subSlash & targetFile))
	End If
Else
	GeneralError = "dc_xml4"   'Can't save edited data
	Set objXMLDoc = nothing
	Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Blog Save Edited Post sub
'
' ****************************************

'Sub that will replace the chosen node with a new node.
Public Sub SaveEditedPost(targetfile,postid)
BackupXML targetFile,writable_dir
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
	GeneralError = "sep_xml2" 'Couldn't parse document
	Exit Sub
End If

Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length

For i = 0 to n_blogs-1
	If blogs.item(i).getAttribute("id") = postid Then
		nodeToReplace = i
	End If
Next

'Create document fragment from the new title/body info then replace the text element with the new fragment.
Set xmlFragment = objXMLDoc.createDocumentFragment()
'Text Element
Set objNewText = objXMLDoc.CreateElement("text")
xmlFragment.appendChild(objNewText)

Set objTextTitle = objXMLDoc.createElement("blogtitle")
Set objTextTitleCD = objXMLDoc.createCDATASection(postTitle)
objTextTitle.appendChild(objTextTitleCD)
objNewText.appendChild(objTextTitle)

Set objTextBody = objXMLDoc.createElement("blogbody")
Set objTextBodyCD = objXMLDoc.createCDATASection(postBody)
objTextBody.appendChild(objTextBodyCD)
objNewText.appendchild(objTextBody)

Set objExch = xmlRoot.childNodes(nodeToReplace).replaceChild(xmlFragment,xmlRoot.childNodes(nodeToReplace).childNodes(2))
Set fs = Server.CreateObject("Scripting.FileSystemObject")

If fs.FolderExists(server.mappath(writable_dir)) = True Then
	objXMLDoc.save(server.mappath(writable_dir & targetFile))
Else
	GeneralError = "xml4"   'Can't save edited data
	Set objXMLDoc = nothing
	Exit Sub
End If

set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Blog Get a single post sub
'
' ****************************************

Public Function GetSinglePost(targetFile,postid_int)
Dim output_array(7)
If postid_int = "" Then
	postid_int = "0"
End If

Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))


Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length

flagFound = false
For i = 0 to n_blogs-1
	If blogs.item(i).getAttribute("id") = postid_int Then
		nodeToRead = i
		flagFound = true
	End If
Next

If flagFound = false Then
	GetSinglePost = 0
	Set objXMLDoc = nothing
	Exit Function
Else
	postid = xmlRoot.childNodes(nodeToRead).getattribute("id")
	authorname = xmlRoot.childNodes(nodeToRead).childNodes(0).childNodes(0).text
	authormail = xmlRoot.childNodes(nodeToRead).childNodes(0).childNodes(1).text
	commentthread = xmlRoot.childNodes(nodeToRead).childNodes(1).childNodes(0).text
	timestamp = xmlRoot.childNodes(nodeToRead).childNodes(1).childNodes(1).text
	language = xmlRoot.childNodes(nodeToRead).childNodes(1).childNodes(2).text
	blog_title = xmlRoot.childNodes(nodeToRead).childNodes(2).childNodes(0).text
	blog_body = xmlRoot.childNodes(nodeToRead).childNodes(2).childNodes(1).text

	Set objXMLDoc = nothing

	output_array(0) = postid
	output_array(1) = authorname
	output_array(2) = authormail
	output_array(3) = commentthread
	output_array(4) = timestamp
	output_array(5) = language
	output_array(6) = blog_title
	output_array(7) = blog_body

	GetSinglePost = output_array
End If
End Function



' ****************************************
' 
' Blog Get Multiple Posts function
'
' ****************************************

'this function is the 'core' of blogworks along with the publishing engine.
'it will return a recordset of the desired posts. The normal mode will return
'Blogger API requirements (array of structs), the extended mode will return BW-XML ones.
'number_of_posts - the number of posts/days returned according to post_type
'ext - extended mode true/false. API - False, BW-XML - True
'mnth - return only current month's posts. For use in publishing engine


Function GetMultiplePosts(number_of_posts,ext,mnth,blogid,categoryID)
'firstly, list all the xml files and sort them into reverse date order - i.e. newest first
set fs=Server.CreateObject("Scripting.FileSystemObject")

If fs.FolderExists(Server.MapPath(writable_dir)) = true Then
	set f=fs.GetFolder(Server.MapPath(writable_dir))
	set fo=f.files
	
		For each file in fo
			If right(file.name,14) = "archive" & blogid & ".xml" Then
				filestring = filestring & "#" & file.name
			End If
		Next

	set fo = nothing
	set f = nothing
	set fs = nothing
	
	If filestring = "" Then
		Exit Function
	End If
	
	filestring = right(filestring,len(filestring)-1)
	filestring = trim(filestring)
	filearray = split(filestring, "#")
	filestring = trim(filestring)

		'Bubblesort the array to find highest file number
		'The idea is to have a continuous index from the array which references the appropriate
		'file name/number - held in the array.

			for x = 0 to ubound(filearray) - 1
			    for y= 0 to ubound(filearray) - 1
			        if filearray(y)>filearray(y+1) then
			            temp=filearray(y+1)
			            filearray(y+1)=filearray(y)
			            filearray(y)=temp
			        end if
			    next
			next

	'create the receiving recordset
	'create fields based on whether we are reacting to Blogger API or not.
	
	Set Blogs = server.CreateObject("ADODB.RECORDSET") 
	Blogs.fields.append "userid",adVarChar,5
	
	If ext = false Then
		Blogs.fields.append "dateCreated",adDate
	Else
		Blogs.fields.append "dateCreated",adVarChar,120
	End If

	If ext = false Then
		Blogs.fields.append "content",adVarChar,256
	End If

	Blogs.fields.append "postid",adVarChar,15

	If ext = true Then
		Blogs.fields.append "authorname",adVarChar,100
		Blogs.fields.append "authormail",adVarChar,150
		Blogs.fields.append "commenthread",adVarChar,15
		Blogs.fields.append "language",adVarChar,2
		Blogs.fields.append "blogtitle",adVarChar,100
		Blogs.fields.append "blogbody",adVarChar,256
		Blogs.fields.append "timestamp",adVarChar,20
		Blogs.fields.append "categoryid",adVarChar,3
		Blogs.fields.append "categoryname",adVarChar,100
	End If
	Blogs.CursorLocation = adUseClient
	Blogs.CursorType = adOpenStatic
	Blogs.open

	'This is the fun bit
	'for each archive xml file open and then for each blog read it into the recordset
	'check the size of the recordset, if it equals the predetermined size from number_of_posts
	'then bomb out and return the recordset
	'If number_of_posts = "0" then all records are returned - so don't do it if you have a million and one blogs

	If mnth = true Then
		lowerRange = ubound(filearray)
	Else
		lowerRange = lbound(filearray)
	End If

	For j = ubound(filearray) to lowerRange step -1
		Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
		objXMLDoc.async = false 
		objXMLDoc.load(server.mappath(writable_dir & filearray(j)))

		Set xmlRoot = objXMLDoc.documentElement
		Set blogsxml = xmlRoot.getElementsByTagName("blog")

		n_blogs = blogsxml.length

		If n_blogs = 0 Then
			Exit Function
		End If


			For i = 0 to n_blogs-1
				postid = xmlRoot.childNodes(i).getattribute("id")
				authorname = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
				authormail = xmlRoot.childNodes(i).childNodes(0).childNodes(1).text
				commentthread = xmlRoot.childNodes(i).childNodes(1).childNodes(0).text
				timestamp = xmlRoot.childNodes(i).childNodes(1).childNodes(1).text
				language = xmlRoot.childNodes(i).childNodes(1).childNodes(2).text
				cat_ID = xmlRoot.childNodes(i).childNodes(1).childNodes(3).childNodes(0).getAttribute("id")
				cat_Name = xmlRoot.childNodes(i).childNodes(1).childNodes(3).childNodes(0).text
				' This is a hack to get around the fact that in
				' v1.0 category ID was included by default as 001 then in
				' v1.1 category ID defaulted to blank.

				If cat_ID = "" Then
					' should be the default category? Yes
					cat_ID = GetDefaultCategory(blog_id)
				End If
				blog_title = xmlRoot.childNodes(i).childNodes(2).childNodes(0).text
				blog_body = xmlRoot.childNodes(i).childNodes(2).childNodes(1).text

				datetime = UnixToHuman(timestamp) 
				
				db_year = left(datetime,4)
				db_month = left(datetime,6)
				db_month = right(db_month,2)
				db_day = left(datetime,8)
				db_day = right(db_day,2)
				db_time = right(datetime,8)
				db_hour = left(db_time,2)
				db_minute = left(db_time,5)
				db_minute = right(db_minute,2)
				db_second = right(db_time,2)
				asp_date = dateserial(db_year,db_month,db_day) + timeserial(db_hour,db_minute,db_second)

				If categoryID = "all" Then
					Blogs.addnew
					Blogs.fields("userid") = CInt(1)
		
					If ext = false Then
						Blogs.fields("dateCreated") = asp_date
					Else
						Blogs.fields("dateCreated") = datetime
					End If
			
					If ext = false Then
						If blog_title = "" Then
							Blogs.fields("content") = ":H:" & blog_body
						Else
							Blogs.fields("content") = blog_title & ":H:" & blog_body 
						End If
					End If
		
					Blogs.fields("postid") = postid
					
					If ext = true Then
						Blogs.fields("authorname") = authorname
						Blogs.fields("authormail") = authormail
						Blogs.fields("commenthread") = commentthread
						Blogs.fields("language") = language
						Blogs.fields("blogtitle") = blog_title
						Blogs.fields("blogbody") = blog_body
						Blogs.fields("timestamp") = timestamp
						Blogs.fields("categoryid") = cat_ID
						Blogs.fields("categoryname") = cat_Name
					End If

				Else
					If cat_ID = categoryID Then
						Blogs.addnew
						Blogs.fields("userid") = CInt(1)
		
						If ext = false Then
							Blogs.fields("dateCreated") = asp_date
						Else
							Blogs.fields("dateCreated") = datetime
						End If
			
						If ext = false Then
							If blog_title = "" Then
								Blogs.fields("content") = ":H:" & blog_body
							Else
								Blogs.fields("content") = blog_title & ":H:" & blog_body 
							End If
						End If
		
						Blogs.fields("postid") = postid
					
						If ext = true Then
							Blogs.fields("authorname") = authorname
							Blogs.fields("authormail") = authormail
							Blogs.fields("commenthread") = commentthread
							Blogs.fields("language") = language
							Blogs.fields("blogtitle") = blog_title
							Blogs.fields("blogbody") = blog_body
							Blogs.fields("timestamp") = timestamp
							Blogs.fields("categoryid") = cat_ID
							Blogs.fields("categoryname") = cat_Name
						End If
					End If
				End If

				If Blogs.RecordCount = CInt(number_of_posts) Then
					StopThing = true
					Exit For
				End If
			Next


			If StopThing = true Then
				Exit For
			End If
			Set objXMLDoc = nothing
	Next
	If Blogs.RecordCount = 0 Then
		Set Blogs = nothing
		Exit Function
	End If

	Blogs.movefirst
	Set GetMultiplePosts = Blogs
	Set Blogs = nothing
End If
End Function



' ****************************************
' 
' Blog - Get Months Post function
'
' ****************************************

Function GetMonthsPosts(file_name,ext,blogid)
'create the receiving recordset
'create fields based on whether weare reacting to Blogger API or not.
Set Blogs = server.CreateObject("ADODB.RECORDSET") 
Blogs.fields.append "userid",adVarChar,5
Blogs.fields.append "dateCreated",adVarChar,120

If ext = false Then
	Blogs.fields.append "content",adVarChar,256
End If

Blogs.fields.append "postid",adVarChar,15

If ext = true Then
	Blogs.fields.append "authorname",adVarChar,100
	Blogs.fields.append "authormail",adVarChar,150
	Blogs.fields.append "commenthread",adVarChar,15
	Blogs.fields.append "language",adVarChar,2
	Blogs.fields.append "blogtitle",adVarChar,100
	Blogs.fields.append "blogbody",adVarChar,256
	Blogs.fields.append "timestamp",adVarChar,20
	Blogs.fields.append "categoryid",adVarChar,3
	Blogs.fields.append "categoryname",adVarChar,100
End If

Blogs.CursorLocation = adUseClient
Blogs.CursorType = adOpenStatic
Blogs.open

'This is the fun bit

Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & file_name))

Set xmlRoot = objXMLDoc.documentElement
Set blogsxml = xmlRoot.getElementsByTagName("blog")
n_blogs = blogsxml.length

If n_blogs = 0 Then
	Exit Function
End If

If archive_order = "0" Then
	strStart = 0
	strFinish = n_blogs-1
	strStep = 1
Else
	strStart = n_blogs-1
	strFinish = 0
	strStep = -1
End If


For i = strStart to strFinish step strStep
	postid = xmlRoot.childNodes(i).getattribute("id")
	authorname = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
	authormail = xmlRoot.childNodes(i).childNodes(0).childNodes(1).text
	commentthread = xmlRoot.childNodes(i).childNodes(1).childNodes(0).text
	timestamp = xmlRoot.childNodes(i).childNodes(1).childNodes(1).text
	language = xmlRoot.childNodes(i).childNodes(1).childNodes(2).text
	cat_ID = xmlRoot.childNodes(i).childNodes(1).childNodes(3).childNodes(0).getAttribute("id")
	cat_Name = xmlRoot.childNodes(i).childNodes(1).childNodes(3).childNodes(0).text
	blog_title = xmlRoot.childNodes(i).childNodes(2).childNodes(0).text
	blog_body = xmlRoot.childNodes(i).childNodes(2).childNodes(1).text

		datetime = UnixToHuman(timestamp) 

		Blogs.addnew
		Blogs.fields("userid") = "1"

		If ext = false Then
			' this needs to be an ASP date time to feed to the xml-rpc server...
			Blogs.fields("dateCreated") = "<dateTime.iso8601>" & datetime & "</dateTime.iso8601>"
		Else
			Blogs.fields("dateCreated") = datetime
		End If
	
		If ext = false Then
			If blog_title = "" Then
				Blogs.fields("content") = blog_body
			Else
				Blogs.fields("content") = blog_title & ":H:" & blog_body
			End If
		End If

		Blogs.fields("postid") = postid

		If ext = true Then
			Blogs.fields("authorname") = authorname
			Blogs.fields("authormail") = authormail
			Blogs.fields("commenthread") = commentthread
			Blogs.fields("language") = language
			Blogs.fields("blogtitle") = blog_title
			Blogs.fields("blogbody") = blog_body
			Blogs.fields("categoryid") = cat_ID
			Blogs.fields("categoryname") = cat_Name
		End If
	Set objXMLDoc = nothing
Next


Blogs.movefirst
Set GetMonthsPosts = Blogs
Set Blogs = nothing
End Function



' ****************************************
' 
' Config functions and subs
'
' ****************************************
' ****************************************
' 
' Config - Create Config file sub
'
' ****************************************

'Create the XML file to be filled.
Public Sub CreateConfig(targetFile)
Set objXMLDoc = Server.CreateObject(bw_xmlCheck) 
Set procBlog = objXMLDoc.createProcessingInstruction("xml","version=""1.0""")
objXMLDoc.appendChild(procBlog)
Set rootBlog = objXMLDoc.createElement("blogconfig")
objXMLDoc.appendChild(rootBlog)
Set objAttr = objXMLDoc.createAttribute("version") 
Set xmlRoot = objXMLDoc.documentElement
xmlRoot.setAttribute "version", "1.1" 

Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & subData)) = True Then
objXMLDoc.save(server.mappath(writable_dir & subData & subSlash & targetFile))
Else
GeneralError = "1.1"
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub



' ****************************************
' 
' Config - Check Config Version
'
' ****************************************
Public Function CheckConfigVersion(targetFile,blogid)
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Function
End If

Set xmlRoot = objXMLDoc.documentElement

config_ver = xmlRoot.getAttribute("version")
CheckConfigVersion = config_ver
Set objXMLDoc = nothing
End Function

' ****************************************
' 
' Config - Append new config
'
' ****************************************

'Add a new blog to the XML file
Public Sub AppendConfig(targetFile,blogid)

BackupXML "config.xml",writable_dir & subData & subSlash

Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Sub
End If

Set xmlRoot = objXMLDoc.documentElement


Set objNewBlog = objXMLDoc.createElement("blog")
objNewBlog.setAttribute "id", blogid 
xmlRoot.insertBefore objNewBlog, xmlRoot.lastChild 

Set objNewStandard = objXMLDoc.createElement("standard")
objNewBlog.appendChild(objNewStandard)

Set objNewName = objXMLDoc.createElement("name")
objNewName.text = blog_name
objNewStandard.appendChild(objNewName)

Set objNewDesc = objXMLDoc.createElement("description")
objNewDesc.text = blog_desc
objNewStandard.appendChild(objNewDesc)

Set objNewMainPage = objXMLDoc.createElement("mainpage")
objNewMainPage.text = blog_main_file
objNewStandard.appendChild(objNewMainPage)

Set objNewArchivePage = objXMLDoc.createElement("archivepage")
objNewArchivePage.text = archive_index_file
objNewStandard.appendChild(objNewArchivePage)

Set objNewLang = objXMLDoc.createElement("language")
objNewLang.text = blog_lang
objNewStandard.appendChild(objNewLang)

Set objNewDateFormat = objXMLDoc.createElement("dateformat")
objNewDateFormat.text = date_format
objNewStandard.appendChild(objNewDateFormat)

Set objNewTimeFormat = objXMLDoc.createElement("timeformat")
objNewTimeFormat.text = time_format
objNewStandard.appendChild(objNewTimeFormat)

Set objNewTimeAdjust = objXMLDoc.createElement("timeadjust")
objNewTimeAdjust.text = time_adjust
objNewStandard.appendChild(objNewTimeAdjust)

Set objNewPerPage = objXMLDoc.createElement("perpage")
objNewPerPage.text = per_page
objNewStandard.appendChild(objNewPerPage)

Set objNewArchDate = objXMLDoc.createElement("archivedateformat")
objNewArchDate.text = archive_date_format
objNewStandard.appendChild(objNewArchDate)

Set objNewArchExt = objXMLDoc.createElement("archiveext")
objNewArchExt.text = archive_ext
objNewStandard.appendChild(objNewArchExt)

Set objNewTimeZone = objXMLDoc.createElement("timezone")
objNewTimeZone.text = time_zone
objNewStandard.appendChild(objNewTimeZone)

Set objNewArchiveOrder = objXMLDoc.createElement("archiveorder")
objNewArchiveOrder.text = archive_order
objNewStandard.appendChild(objNewArchiveOrder)

Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & subData & subSlash)) = True Then
objXMLDoc.save(server.mappath(writable_dir & subData & subSlash & targetFile))
Else
GeneralError = "1.3"   'Can't save appended data
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Config - Delete config sub (not in use)
'
' ****************************************

Public Sub DeleteConfig(targetfile,blogid)

BackupXML "config.xml",writable_dir & subData & subSlash

Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Sub
End If
Set xmlRoot = objXMLDoc.documentElement
Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
For i = 0 to n_blogs-1
If blogs.item(i).getAttribute("id") = postid Then
nodeToRemove = i
End If
Next
Set objExNode = xmlRoot.removeChild(xmlRoot.childNodes.item(nodeToRemove)) 
Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & subData & subSlash)) = True Then
objXMLDoc.save(server.mappath(writable_dir & subData & subSlash & targetFile))
Else
GeneralError = "1.4"   'Can't save edited data
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Config - Save Edited Config
'
' ****************************************

'Sub that will replace the chosen node with a new node.
Public Sub SaveEditedConfig(targetfile,blogid)

BackupXML "config.xml",writable_dir & subData & subSlash

Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
Set ParseErr = objXMLDoc.parseError 
If ParseErr.errorCode <> 0 Then 
GeneralError = 1.2 'Couldn't parse document
Exit Sub
End If
Set xmlRoot = objXMLDoc.documentElement


Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
For i = 0 to n_blogs-1
If blogs.item(i).getAttribute("id") = blogid Then
nodeToReplace = i
End If
Next
Set xmlFragment = objXMLDoc.createDocumentFragment()

Set objNewConfig = objXMLDoc.createElement("blog")
objNewConfig.setAttribute "id", blogid 
xmlFragment.appendChild(objNewConfig)

Set objNewBlog = objXMLDoc.createElement("standard")
objNewConfig.appendChild(objNewBlog)

Set objNewName = objXMLDoc.createElement("name")
objNewName.text = blog_name
objNewBlog.appendChild(objNewName)

Set objNewDesc = objXMLDoc.createElement("description")
objNewDesc.text = blog_desc
objNewBlog.appendChild(objNewDesc)

Set objNewMainPage = objXMLDoc.createElement("mainpage")
objNewMainPage.text = blog_main_file
objNewBlog.appendChild(objNewMainPage)

Set objNewArchivePage = objXMLDoc.createElement("archivepage")
objNewArchivePage.text = archive_index_file
objNewBlog.appendChild(objNewArchivePage)

Set objNewLang = objXMLDoc.createElement("language")
objNewLang.text = blog_lang
objNewBlog.appendChild(objNewLang)

Set objNewDateFormat = objXMLDoc.createElement("dateformat")
objNewDateFormat.text = date_format
objNewBlog.appendChild(objNewDateFormat)

Set objNewTimeFormat = objXMLDoc.createElement("timeformat")
objNewTimeFormat.text = time_format
objNewBlog.appendChild(objNewTimeFormat)

Set objNewTimeAdjust = objXMLDoc.createElement("timeadjust")
objNewTimeAdjust.text = time_adjust
objNewBlog.appendChild(objNewTimeAdjust)

Set objNewPerPage = objXMLDoc.createElement("perpage")
objNewPerPage.text = per_page
objNewBlog.appendChild(objNewPerPage)

Set objNewArchDate = objXMLDoc.createElement("archivedateformat")
objNewArchDate.text = archive_date_format
objNewBlog.appendChild(objNewArchDate)

Set objNewArchExt = objXMLDoc.createElement("archiveext")
objNewArchExt.text = archive_ext
objNewBlog.appendChild(objNewArchExt)

Set objNewTimeZone = objXMLDoc.createElement("timezone")
objNewTimeZone.text = time_zone
objNewBlog.appendChild(objNewTimeZone)

Set objNewArchiveOrder = objXMLDoc.createElement("archiveorder")
objNewArchiveOrder.text = archive_order
objNewBlog.appendChild(objNewArchiveOrder)

Set objExch = xmlRoot.replaceChild(xmlFragment,xmlRoot.childNodes(nodeToReplace))
Set objExch = nothing


Set fs = Server.CreateObject("Scripting.FileSystemObject")
If fs.FolderExists(server.mappath(writable_dir & subData & subSlash)) = True Then
objXMLDoc.save(server.mappath(writable_dir & subData & subSlash & targetFile))
Else
GeneralError = "1.4"   'Can't save edited data
Exit Sub
End If
set fs = nothing
Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Config - Cache Blog Listing
'
' ****************************************

Public Sub CacheBlogList(targetFile)
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
Set xmlRoot = objXMLDoc.documentElement

Set blogs = xmlRoot.getElementsByTagName("blog")
n_blogs = blogs.length
Session("bloglist_cnt") = n_blogs
For i = 0 to n_blogs-1
oblogid = xmlRoot.childNodes(i).getattribute("id")
If left(oblogid,2) = "00" Then
blogno = right(oblogid,1) & "."
ElseIf left(oblogid,1) = "0" Then
blogno = right(oblogid,2) & "."
End If

oblog_name = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
If blog_id = oblogid Then
optn = optn & "<option value=""" & oblogid & """ selected=""selected"">" & left(oblog_name,14) & "</option>"
Else
optn = optn & "<option value=""" & oblogid & """>" & left(oblog_name,14) & "</option>"
End If
Next

For i = 1 to n_blogs-1
oblogid = xmlRoot.childNodes(i).getattribute("id")
If left(oblogid,2) = "00" Then
blogno = right(oblogid,1) & "."
ElseIf left(oblogid,1) = "0" Then
blogno = right(oblogid,2) & "."
End If
oblog_name = xmlRoot.childNodes(i).childNodes(0).childNodes(0).text
optn2 = optn2 & "<option value=""" & oblogid & """>&#149;&nbsp;" & oblog_name & "</option>"
Next

oblogid = ""
oblog_name =""
Session("bloglist") = optn
Session("bloglist_clr") = optn2
Session("bloglist_cnt") = n_blogs
End Sub


' ****************************************
' 
' Config - Count Configs
'
' ****************************************

Public Function CountConfigs(targetFile)
	Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
	objXMLDoc.async = false 
	objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
	Set xmlRoot = objXMLDoc.documentElement
	Set blogs = xmlRoot.getElementsByTagName("blog")
	n_blogs = blogs.length
	CountConfigs = n_blogs
End Function

Public Function ConfigCountByBlog(blogID,targetFile)
	Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
	objXMLDoc.async = false 
	objXMLDoc.setProperty "SelectionLanguage","XPath" 
	objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
	Set xmlRoot = objXMLDoc.documentElement
	sXPath = "//blog[last()]"
	Set configList = xmlRoot.selectSingleNode(sXPath)
		
	strCount = configList.getAttribute("id") 
	If left(strCount,2) = "00" Then
		strCount = right(strCount,1)
	End If
	If left(strCount,1) = "0" Then
		strCount = right(strCount,2)
	End If	
ConfigCountByBlog = strCount
End Function


' ****************************************
' 
' Config - Read Config file
' 
' ****************************************
Public Function GetConfigItem(targetFile,blogID,cfgItem)
	If blogID = "" Then
		blogID = "001"
	End If
	Set objXMLDocInt = Server.CreateObject("Microsoft.XMLDOM")
	objXMLDocInt.async = false 
	objXMLDocInt.setProperty "SelectionLanguage","XPath" 
	objXMLDocInt.load(server.mappath(writable_dir & subData & subSlash & targetFile))
	Set xmlRoot = objXMLDocInt.documentElement

	sXPath = "//blog[@id='" & blogID & "']"
	GCI = xmlRoot.selectSingleNode(sXPath & "/standard/" & cfgItem).text
	Set objXMLDocInt = nothing
	GetConfigItem = GCI
End Function

Public Sub ReadConfig(targetFile,blogid)
' now that config files are checked and upgraded in one hit when v1.1 is run for the first time we don't need
' to worry about whether or not we're trying to read a 1.0 or 1.1 version config file.

If blogid = "" Then
blogid = "001"
End If
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.setProperty "SelectionLanguage","XPath" 
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
Set xmlRoot = objXMLDoc.documentElement

sXPath = "//blog[@id='" & blogid & "']"

'Set mConfig = xmlRoot.selectNodes(sXPath)

blog_id = blogid
blog_name = xmlRoot.selectSingleNode(sXPath & "/standard/name").text
blog_desc = xmlRoot.selectSingleNode(sXPath & "/standard/description").text
blog_main_file = xmlRoot.selectSingleNode(sXPath & "/standard/mainpage").text
archive_index_file = xmlRoot.selectSingleNode(sXPath & "/standard/archivepage").text
blog_lang = xmlRoot.selectSingleNode(sXPath & "/standard/language").text
date_format = xmlRoot.selectSingleNode(sXPath & "/standard/dateformat").text
time_format = xmlRoot.selectSingleNode(sXPath & "/standard/timeformat").text
time_adjust = xmlRoot.selectSingleNode(sXPath & "/standard/timeadjust").text
per_page = xmlRoot.selectSingleNode(sXPath & "/standard/perpage").text
archive_date_format = xmlRoot.selectSingleNode(sXPath & "/standard/archivedateformat").text
archive_ext = xmlRoot.selectSingleNode(sXPath & "/standard/archiveext").text
time_zone = xmlRoot.selectSingleNode(sXPath & "/standard/timezone").text
archive_order = xmlRoot.selectSingleNode(sXPath & "/standard/archiveorder").text

Set objXMLDoc = nothing
End Sub


' ****************************************
' 
' Syndication - Read Format file
' 
' ****************************************
Private Function addZeros(strInput)
	If len(strInput) = 3 Then
		pString = strInput
	ElseIf len(strInput) = 2 Then
		pString = "0" & strInput
	ElseIf len(strInput) = 1 Then
		pString = "00" & strInput
	End If
addZeros = pString
End Function

Public Function ReadFormats()
Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
objXMLDoc.async = false 
objXMLDoc.setProperty "SelectionLanguage","XPath" 
objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & "syndication_formats.xml"))
Set xmlRoot = objXMLDoc.documentElement

sXPath = "//format"

Set ReadFormats = xmlRoot.selectNodes(sXPath)
Set objXMLDoc = nothing

End Function


Public Function listNodes(blogID,strType,strFileName)
	If blogID = "" Then
		blogID = "001"
	End If
	Set objXMLDocInt = Server.CreateObject("Microsoft.XMLDOM")
	objXMLDocInt.async = false 
	objXMLDocInt.setProperty "SelectionLanguage","XPath" 
	objXMLDocInt.load(server.mappath(writable_dir & subData & subSlash & strFileName))
	Set xmlRootInt = objXMLDocInt.documentElement

	sXPath = "//blog[@id='" & blogID & "']"
	set GFL = xmlRootInt.selectNodes(sXPath & "/" & strType)
	Set objXMLDocInt = nothing
	set listNodes = GFL
End Function

Public Function readNode(blogID,nodeAlias,strType,strFileName)
	If blogID = "" Then
		blogID = "001"
	End If
	Set objXMLDocInt = Server.CreateObject("Microsoft.XMLDOM")
	objXMLDocInt.async = false 
	objXMLDocInt.setProperty "SelectionLanguage","XPath" 
	objXMLDocInt.load(server.mappath(writable_dir & subData & subSlash & strFileName))
	Set xmlRoot = objXMLDocInt.documentElement

	sXPath = "//blog[@id='" & blogID & "']/" & strType & "[@alias='" & nodeAlias & "']"
	set GFL = xmlRoot.selectNodes(sXPath)
	Set objXMLDocInt = nothing
	set readNode = GFL
End Function

' Generic 'add' thing for xml file to add XML in form
' <outerelement><item></item><item2></item2></outerelement>

Function addXMLFragment(targetFile,blogID,strElementName,arrNames,arrContents)
	If ubound(arrNames) <> ubound(arrContents) Then
		addXMLFragment = false
		Exit Function
	End If

	Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
	objXMLDoc.async = false
	objXMLDoc.setProperty "SelectionLanguage","XPath" 
	objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
	Set ParseErr = objXMLDoc.parseError 
	If ParseErr.errorCode <> 0 Then 
		addXMLFragment = false 'Couldn't parse document
		Exit Function
	End If

	Set xmlRoot = objXMLDoc.documentElement

	sXPath = "//blog[@id='" & blogID & "']"
	set itemList = xmlRoot.selectNodes(sXPath & "/" & strElementName)
	itemCount = itemList.length
	
	Set blogs = xmlRoot.getElementsByTagName("blog")
	n_blogs = blogs.length
	For i = 0 to n_blogs-1
		If blogs.item(i).getAttribute("id") = blogID Then
			nodeToAdd = i
		End If
	Next

	Set xmlFragment = objXMLDoc.createDocumentFragment()

	Set objNewFrag = objXMLDoc.createElement(strElementName)
	objNewFrag.setAttribute "alias", arrContents(0)

	xmlFragment.appendChild(objNewFrag)

	For i = 1 to ubound(arrNames)
		Set objNewElement = objXMLDoc.createElement(arrNames(i))
		objNewElement.text = entityEncode(arrContents(i))
		objNewFrag.appendChild(objNewElement)	
	Next

	xmlRoot.childNodes(nodeToAdd).appendChild(xmlFragment)
	objXMLDoc.save(server.mappath(writable_dir & subData & subSlash & targetFile))
	addXMLFragment = true
End Function

Function editXMLFragment(targetFile,blogID,strElementName,arrNames,arrContents)
	If ubound(arrNames) <> ubound(arrContents) Then
		editXMLFragment = false
		Exit Function
	End If

	Set objXMLDoc = Server.CreateObject(bw_xmlCheck)
	objXMLDoc.async = false
	objXMLDoc.setProperty "SelectionLanguage","XPath" 
	objXMLDoc.load(server.mappath(writable_dir & subData & subSlash & targetFile))
	Set ParseErr = objXMLDoc.parseError 
	If ParseErr.errorCode <> 0 Then 
		editXMLFragment = false 'Couldn't parse document
		Exit Function
	End If

	Set xmlRoot = objXMLDoc.documentElement

	sXPath = "//blog[@id='" & blogID & "']/" & strElementName & "[@alias='" & arrContents(0) &"']"
	set itemList = xmlRoot.selectNodes(sXPath)
	
	For i = 1 to ubound(arrNames)
		Set objNewElement = objXMLDoc.createElement(arrNames(i))
		objNewElement.text = entityEncode(arrContents(i))
		itemList(0).replaceChild objNewElement, itemList(0).selectSingleNode(arrNames(i))

	Next

	objXMLDoc.save(server.mappath(writable_dir & subData & subSlash & targetFile))
	editXMLFragment = true
End Function

Function deleteXMLFragment(fileSpec,strElementName,strElementAlias)
xmlData = ReadXMLText(fileSpec)

	Dim regEx
	Set regEx = New RegExp
	regEx.Pattern = "<" & strElementName & " alias=""" & strElementAlias & """>.*?</" & strElementName & ">"
	regEx.IgnoreCase = True
	regEx.Global = True
	xmlData = regEx.Replace(xmlData,"")
	Set regEx = nothing

SaveXMLText fileSpec, xmlData
End Function

Function ReadXMLText(fileName)
	set fls=Server.CreateObject("Scripting.FileSystemObject")
	If fls.FileExists(server.mappath(writable_dir & subData & subSlash & fileName)) = true Then
		flname = (server.mappath(writable_dir & subData & subSlash & fileName))
		set txtfile = fls.OpenTextFile(flname, 1, 0)
		data = txtfile.ReadAll
		txtfile.close
		set txtfile = nothing
		set fls = nothing
	End If
	ReadXMLText = data
End Function

Function SaveXMLText(fileName,strConfig)
	set fls=Server.CreateObject("Scripting.FileSystemObject")
	'If fls.FileExists(server.mappath(writable_dir & subData & subSlash & fileName)) = true Then
		flname = (server.mappath(writable_dir & subData & subSlash & fileName))
		set txtfile = fls.OpenTextFile(flname, 2, 1)
		txtfile.write strConfig
		txtfile.close
		set txtfile = nothing
		set fls = nothing
	'End If
End Function


Function CheckArchivesExist(blogid)
	set fs=Server.CreateObject("Scripting.FileSystemObject")
	If fs.FolderExists(Server.MapPath(writable_dir)) = true Then
		set f=fs.GetFolder(Server.MapPath(writable_dir))
		set fo=f.files
	
		For each file in fo
			If right(file.name,14) = "archive" & blogid & ".xml" Then
				filestring = filestring & "#" & file.name
			End If
		Next
		If filestring = "" Then
			chkArchives = false 
		Else
			chkArchives = true
		End If
	Else
		chkArchives = false
	End If
	Set fs = nothing
	CheckArchivesExist = chkArchives
End Function

Function CheckFileExists(byVal fileSpec)
	Dim fileChk
	Set fso = CreateObject("Scripting.FileSystemObject")
	If fso.fileExists(server.mappath(fileSpec)) Then
		fileChk = true
	Else
		fileChk = false
	End If
	CheckFileExists = fileChk
End Function

Function GetDefaultCategory(blogID)
	set catList = listNodes(blogID,"category","categories.xml")
	If catList.length = 1 Then
		strOutput = catList(0).selectSingleNode("id").text
	Else
		For Each Item in catList
			catDefault = Item.selectSingleNode("default").text
			If catDefault = "true" Then
				strOutput = Item.selectSingleNode("id").text
				Exit For
			End If
		Next
	End If
	set catList = nothing
	GetDefaultCategory = strOutput
End Function

Function GetCategoryFromID(blogID,catID)
	set catList = listNodes(blogID,"category","categories.xml")
	For Each Item in catList
		retCatID = Item.selectSingleNode("id").text
		If retCatID = catID Then
			strOutput = Item.selectSingleNode("name").text
			Exit For
		End If
	Next
	set catList = nothing
	GetCategoryFromID = strOutput
End Function
%>
